(set-logic QF_NIA)
(set-info
  :source |
SMT script generated by Ultimate LassoRanker [1].
Ultimate LassoRanker is a tool that analyzes termination and nontermination of 
lasso-shaped programs. This script contains the SMT commands that Ultimate 
LassoRanker used while checking if a lasso-shaped program has a geometric 
nontermination argument [2].

This SMT script belongs to a set of SMT scripts that was generated by applying
Ultimate Buchi Automizer [3,4] to the benchmarks from the SV-COMP 2015 [5,6] 
which are available at [7]. Ultimate Buchi Automizer takes omega-traces
(lasso-shaped programs) and uses LassoRanker in order to check if the 
lasso-shaped program is terminating.

2015-04-30, Matthias Heizmann (heizmann@informatik.uni-freiburg.de)


[1] https://ultimate.informatik.uni-freiburg.de/LassoRanker/
[2] Jan Leike, Matthias Heizmann:
Geometric Series as Nontermination Arguments for Linear Lasso Programs. 
CoRR abs/1405.4413 (2014)
http://arxiv.org/abs/1405.4413
[3] http://ultimate.informatik.uni-freiburg.de/BuchiAutomizer/
[4] Matthias Heizmann, Jochen Hoenicke, Andreas Podelski: Software Model 
Checking for People Who Love Automata. CAV 2013:36-52
[5] http://sv-comp.sosy-lab.org/2015/
[6] Dirk Beyer: Software Verification and Verifiable Witnesses - (Report on 
SV-COMP 2015). TACAS 2015: 401-416
[7] https://svn.sosy-lab.org/software/sv-benchmarks/tags/svcomp15/
|)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun |init_main_#t~malloc10.offset| () Int)
(declare-fun |honda_main_#t~malloc10.offset| () Int)
(declare-fun |ray_main_#t~malloc10.offset| () Int)
(declare-fun |init_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid 0) 1 0)| () Int)
(declare-fun init_main_~id~2.offset () Int)
(declare-fun honda_main_~id~2.offset () Int)
(declare-fun ray_main_~id~2.offset () Int)
(declare-fun |init_main_#t~malloc0.base| () Int)
(declare-fun |honda_main_#t~malloc0.base| () Int)
(declare-fun |ray_main_#t~malloc0.base| () Int)
(declare-fun |init_(ite main_#t~short9 1 0)| () Int)
(declare-fun |honda_(ite main_#t~short9 1 0)| () Int)
(declare-fun |ray_(ite main_#t~short9 1 0)| () Int)
(declare-fun |init_main_#t~malloc1.offset| () Int)
(declare-fun |honda_main_#t~malloc1.offset| () Int)
(declare-fun |ray_main_#t~malloc1.offset| () Int)
(declare-fun |init_main_#t~mem6| () Int)
(declare-fun |honda_main_#t~mem6| () Int)
(declare-fun |ray_main_#t~mem6| () Int)
(declare-fun |init_main_#t~mem7| () Int)
(declare-fun |honda_main_#t~mem7| () Int)
(declare-fun |ray_main_#t~mem7| () Int)
(declare-fun |init_main_#t~mem8| () Int)
(declare-fun |honda_main_#t~mem8| () Int)
(declare-fun |ray_main_#t~mem8| () Int)
(declare-fun init_main_~tmp~3.base () Int)
(declare-fun honda_main_~tmp~3.base () Int)
(declare-fun ray_main_~tmp~3.base () Int)
(declare-fun |init_main_#t~malloc1.base| () Int)
(declare-fun |honda_main_#t~malloc1.base| () Int)
(declare-fun |ray_main_#t~malloc1.base| () Int)
(declare-fun |init_main_#t~nondet2| () Int)
(declare-fun |honda_main_#t~nondet2| () Int)
(declare-fun |ray_main_#t~nondet2| () Int)
(declare-fun |init_main_#t~mem11| () Int)
(declare-fun |honda_main_#t~mem11| () Int)
(declare-fun |ray_main_#t~mem11| () Int)
(declare-fun |init_main_#t~mem16| () Int)
(declare-fun |honda_main_#t~mem16| () Int)
(declare-fun |ray_main_#t~mem16| () Int)
(declare-fun |init_main_#t~mem13| () Int)
(declare-fun |honda_main_#t~mem13| () Int)
(declare-fun |ray_main_#t~mem13| () Int)
(declare-fun |init_main_#t~mem18| () Int)
(declare-fun |honda_main_#t~mem18| () Int)
(declare-fun |ray_main_#t~mem18| () Int)
(declare-fun init_main_~maxId~2.offset () Int)
(declare-fun honda_main_~maxId~2.offset () Int)
(declare-fun ray_main_~maxId~2.offset () Int)
(declare-fun |init_main_#t~malloc10.base| () Int)
(declare-fun |honda_main_#t~malloc10.base| () Int)
(declare-fun |ray_main_#t~malloc10.base| () Int)
(declare-fun |init_main_#t~nondet4| () Int)
(declare-fun |honda_main_#t~nondet4| () Int)
(declare-fun |ray_main_#t~nondet4| () Int)
(declare-fun |init_main_#t~nondet15| () Int)
(declare-fun |honda_main_#t~nondet15| () Int)
(declare-fun |ray_main_#t~nondet15| () Int)
(declare-fun |init_main_#t~mem17| () Int)
(declare-fun |honda_main_#t~mem17| () Int)
(declare-fun |ray_main_#t~mem17| () Int)
(declare-fun |init_main_#t~mem14| () Int)
(declare-fun |honda_main_#t~mem14| () Int)
(declare-fun |ray_main_#t~mem14| () Int)
(declare-fun init_main_~maxId~2.base () Int)
(declare-fun honda_main_~maxId~2.base () Int)
(declare-fun ray_main_~maxId~2.base () Int)
(declare-fun init_main_~id~2.base () Int)
(declare-fun honda_main_~id~2.base () Int)
(declare-fun ray_main_~id~2.base () Int)
(declare-fun |init_#NULL.offset| () Int)
(declare-fun |honda_#NULL.offset| () Int)
(declare-fun |ray_#NULL.offset| () Int)
(declare-fun |init_main_#t~malloc0.offset| () Int)
(declare-fun |honda_main_#t~malloc0.offset| () Int)
(declare-fun |ray_main_#t~malloc0.offset| () Int)
(declare-fun init_main_~tmp~3.offset () Int)
(declare-fun honda_main_~tmp~3.offset () Int)
(declare-fun ray_main_~tmp~3.offset () Int)
(declare-fun |init_#NULL.base| () Int)
(declare-fun |honda_#NULL.base| () Int)
(declare-fun |ray_#NULL.base| () Int)
(declare-fun |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| ()
  Int)
(declare-fun |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| () Int)
(declare-fun
  |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
  () Int)
(declare-fun |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| () Int)
(declare-fun |honda_(select old(#length) main_~tmp~3.base)| () Int)
(declare-fun |ray_(select old(#length) main_~tmp~3.base)| () Int)
(declare-fun
  |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
  () Int)
(declare-fun |honda_(ite (select #valid main_~tmp~3.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid main_~tmp~3.base) 1 0)| () Int)
(declare-fun
  |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| ()
  Int)
(declare-fun
  |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| ()
  Int)
(declare-fun |honda_(select old(#length) main_~id~2.base)| () Int)
(declare-fun |ray_(select old(#length) main_~id~2.base)| () Int)
(declare-fun |honda_(select #length main_~id~2.base)| () Int)
(declare-fun |ray_(select #length main_~id~2.base)| () Int)
(declare-fun
  |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
  () Int)
(declare-fun |honda_(select #length main_~maxId~2.base)| () Int)
(declare-fun |ray_(select #length main_~maxId~2.base)| () Int)
(declare-fun |honda_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun
  |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
  () Int)
(declare-fun |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| () Int)
(declare-fun
  |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
  () Int)
(declare-fun
  |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)| ()
  Int)
(declare-fun |honda_(select old(#length) main_~maxId~2.base)| () Int)
(declare-fun |ray_(select old(#length) main_~maxId~2.base)| () Int)
(declare-fun |honda_(ite (select #valid main_~maxId~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid main_~maxId~2.base) 1 0)| () Int)
(declare-fun |honda_(select #length main_~tmp~3.base)| () Int)
(declare-fun |ray_(select #length main_~tmp~3.base)| () Int)
(declare-fun |honda_(ite (select #valid main_~id~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid main_~id~2.base) 1 0)| () Int)
(declare-fun lambda () Int)
(declare-fun aux_1188 () Int)
(declare-fun aux_1189 () Int)
(declare-fun aux_1192 () Int)
(declare-fun aux_1193 () Int)
(declare-fun aux_1196 () Int)
(declare-fun aux_1197 () Int)
(declare-fun aux_1200 () Int)
(declare-fun aux_1201 () Int)
(declare-fun aux_1204 () Int)
(declare-fun aux_1205 () Int)
(declare-fun aux_1208 () Int)
(declare-fun aux_1209 () Int)
(declare-fun aux_1212 () Int)
(declare-fun aux_1213 () Int)
(declare-fun aux_1216 () Int)
(declare-fun aux_1217 () Int)
(declare-fun aux_1220 () Int)
(declare-fun aux_1221 () Int)
(declare-fun aux_1224 () Int)
(declare-fun aux_1225 () Int)
(declare-fun aux_1228 () Int)
(declare-fun aux_1229 () Int)
(declare-fun aux_1232 () Int)
(declare-fun aux_1233 () Int)
(declare-fun aux_1236 () Int)
(declare-fun aux_1237 () Int)
(declare-fun aux_1240 () Int)
(declare-fun aux_1241 () Int)
(declare-fun aux_1244 () Int)
(declare-fun aux_1245 () Int)
(declare-fun aux_1248 () Int)
(declare-fun aux_1249 () Int)
(declare-fun aux_1252 () Int)
(declare-fun aux_1253 () Int)
(declare-fun aux_1256 () Int)
(declare-fun aux_1257 () Int)
(declare-fun aux_1260 () Int)
(declare-fun aux_1261 () Int)
(declare-fun aux_1264 () Int)
(declare-fun aux_1265 () Int)
(declare-fun aux_1268 () Int)
(declare-fun aux_1269 () Int)
(declare-fun aux_1272 () Int)
(declare-fun aux_1273 () Int)
(declare-fun aux_1276 () Int)
(declare-fun aux_1277 () Int)
(declare-fun aux_1280 () Int)
(declare-fun aux_1281 () Int)
(assert
 (and
 (or
 (and (= |init_main_#t~mem18| |honda_main_#t~mem18|)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| (- 1))
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1)) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1188 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base (- 1)) 
 (* honda_main_~id~2.base 1)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 1)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 1)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 1) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| (- 1))
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(select #length main_~tmp~3.base)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 1)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1189 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 1) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1188 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 1) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset (- 1))
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 1) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset (- 1)) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1189 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 1)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 1)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 1)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem18| |honda_main_#t~mem18|)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| (- 1))
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1)) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1192 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 1)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 1)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 1) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| (- 1))
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(select #length main_~tmp~3.base)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 1)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1193 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1192 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 1) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 1) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 1)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset (- 1))
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 1) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset (- 1)) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 1) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base (- 1))
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1193 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 1)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 1)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 1)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem18| |honda_main_#t~mem18|)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| (- 1))
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1)) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1196 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 1)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 1)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 1) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| (- 1))
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(select #length main_~tmp~3.base)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 1)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base (- 1)) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1197 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1196 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 1) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 1)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset (- 1))
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 1) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset (- 1)) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 1) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base (- 1))
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1197 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 1)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 1)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 1)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem18| |honda_main_#t~mem18|)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| (- 1))
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1)) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1200 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 1)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 1)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 1) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| (- 1))
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(select #length main_~tmp~3.base)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 1)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base (- 1)) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1201 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1200 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 1)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 1) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset (- 1))
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 1) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset (- 1)) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1201 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 1)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 1) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 1)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 1)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem18| |honda_main_#t~mem18|)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| (- 1))
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1)) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1204 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 1)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 1)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 1) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| (- 1))
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 1) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base (- 1)) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(select #length main_~tmp~3.base)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 1)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1205 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1204 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base (- 1))
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 1)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 1) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset (- 1))
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 1) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset (- 1)) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1205 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 1)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 1)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 1)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem18| |honda_main_#t~mem18|)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| (- 1))
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1)) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1208 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 1)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 1)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 1) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| (- 1))
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 1) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base (- 1)) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(select #length main_~tmp~3.base)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 1)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1209 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1208 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 1) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 1)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset (- 1))
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 1) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset (- 1)) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1209 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 1)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 1)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 1)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem18| |honda_main_#t~mem18|)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| (- 1))
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1)) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1212 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 1)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 1)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 1) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| (- 1))
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 1) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base (- 1)) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(select #length main_~tmp~3.base)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 1)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1213 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 1) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1212 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base (- 1))
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 1) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset (- 1))
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 1) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset (- 1)) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1213 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 1)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 1)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 1)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem18| |honda_main_#t~mem18|)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| (- 1))
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1)) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1216 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 1)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 1)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 1) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| (- 1))
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(select #length main_~tmp~3.base)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 1)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1217 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 1) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1216 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 1) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset (- 1))
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 1) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset (- 1)) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 1) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base (- 1))
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1217 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 1)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 1)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 1)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem18| |honda_main_#t~mem18|)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| (- 1))
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 1) 
 (* honda_main_~id~2.base (- 1))
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1)) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1220 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 1)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 1)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 1) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| (- 1))
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 1) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base (- 1)) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(select #length main_~tmp~3.base)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 1)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1221 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1220 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 1) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 1)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset (- 1))
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 1) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset (- 1)) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1221 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 1)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 1)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 1)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem18| |honda_main_#t~mem18|)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| (- 1))
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1)) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1224 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base (- 1)) 
 (* honda_main_~id~2.base 1)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 1)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 1)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 1) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| (- 1))
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(select #length main_~tmp~3.base)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 1)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1225 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 1) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1224 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 1) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset (- 1))
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 1) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset (- 1)) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 1) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base (- 1))
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1225 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 1)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 1)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 1)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem18| |honda_main_#t~mem18|)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| (- 1))
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1)) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1228 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 1)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 1)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 1) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| (- 1))
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(select #length main_~tmp~3.base)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 1)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1229 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1228 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base (- 1))
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 1) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 1) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset (- 1))
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 1) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset (- 1)) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1229 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 1)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 1) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 1)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 1)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem18| |honda_main_#t~mem18|)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| (- 1))
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1)) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1232 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 1)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 1)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 1) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| (- 1))
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(select #length main_~tmp~3.base)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 1)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base (- 1)) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1233 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1232 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 1) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 1) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 1)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset (- 1))
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 1) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset (- 1)) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1233 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 1)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 1)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 1)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem18| |honda_main_#t~mem18|)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| (- 1))
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1)) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1236 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 1)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 1)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 1) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| (- 1))
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(select #length main_~tmp~3.base)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 1)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1237 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 1) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1236 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base (- 1))
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 1)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 1) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset (- 1))
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 1) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset (- 1)) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1237 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 1)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 1)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 1)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem18| |honda_main_#t~mem18|)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| (- 1))
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1)) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1240 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 1)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 1)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 1) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| (- 1))
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 1) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base (- 1)) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(select #length main_~tmp~3.base)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 1)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1241 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 1) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1240 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 1)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 1) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset (- 1))
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 1) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset (- 1)) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1241 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 1)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 1)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 1)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem18| |honda_main_#t~mem18|)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| (- 1))
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 1) 
 (* honda_main_~id~2.base (- 1))
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1)) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1244 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 1)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 1)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 1) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| (- 1))
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(select #length main_~tmp~3.base)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 1)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base (- 1)) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1245 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1244 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 1)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 1) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset (- 1))
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 1) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset (- 1)) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1245 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 1)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 1)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 1)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem18| |honda_main_#t~mem18|)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| (- 1))
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1)) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1248 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base (- 1)) 
 (* honda_main_~id~2.base 1)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 1)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 1)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 1) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| (- 1))
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(select #length main_~tmp~3.base)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 1)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1249 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1248 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 1) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 1) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset (- 1))
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 1) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset (- 1)) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1249 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 1)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 1) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 1)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 1)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem18| |honda_main_#t~mem18|)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| (- 1))
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1)) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1252 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base (- 1)) 
 (* honda_main_~id~2.base 1)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 1)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 1)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 1) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| (- 1))
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(select #length main_~tmp~3.base)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 1)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1253 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1252 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 1) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset (- 1))
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 1) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset (- 1)) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 1) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base (- 1))
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1253 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 1)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 1)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 1)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem18| |honda_main_#t~mem18|)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| (- 1))
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1)) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1256 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base (- 1)) 
 (* honda_main_~id~2.base 1)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 1)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 1)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 1) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| (- 1))
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(select #length main_~tmp~3.base)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 1)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1257 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1256 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base (- 1))
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 1) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 1) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset (- 1))
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 1) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset (- 1)) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1257 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 1)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 1)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 1)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem18| |honda_main_#t~mem18|)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| (- 1))
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 1) 
 (* honda_main_~id~2.base (- 1))
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1)) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1260 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 1)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 1)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 1) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| (- 1))
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(select #length main_~tmp~3.base)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 1)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base (- 1)) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1261 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1260 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 1) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset (- 1))
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 1) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset (- 1)) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1261 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 1)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 1) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 1)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 1)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem18| |honda_main_#t~mem18|)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| (- 1))
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 1) 
 (* honda_main_~id~2.base (- 1))
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1)) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1264 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 1)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 1)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 1) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| (- 1))
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 1) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base (- 1)) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(select #length main_~tmp~3.base)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 1)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1265 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1264 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 1) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset (- 1))
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 1) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset (- 1)) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1265 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 1)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 1)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 1)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem18| |honda_main_#t~mem18|)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| (- 1))
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1)) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1268 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base (- 1)) 
 (* honda_main_~id~2.base 1)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 1)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 1)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 1) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| (- 1))
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(select #length main_~tmp~3.base)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 1)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1269 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1268 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base (- 1))
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 1) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset (- 1))
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 1) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset (- 1)) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1269 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 1)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 1) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 1)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 1)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem18| |honda_main_#t~mem18|)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| (- 1))
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 1) 
 (* honda_main_~id~2.base (- 1))
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1)) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1272 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 1)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 1)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 1) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| (- 1))
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(select #length main_~tmp~3.base)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 1)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1273 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1272 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 1)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 1) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset (- 1))
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 1) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset (- 1)) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1273 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 1)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 1) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 1)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 1)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem18| |honda_main_#t~mem18|)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| (- 1))
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 1) 
 (* honda_main_~id~2.base (- 1))
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1)) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1276 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 1)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 1)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 1) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| (- 1))
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(select #length main_~tmp~3.base)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 1)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1277 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1276 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 1) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 1)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset (- 1))
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 1) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset (- 1)) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1277 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 1)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 1)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 1)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem18| |honda_main_#t~mem18|)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| (- 1))
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1)) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1280 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 1)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 1)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 1) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| (- 1))
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0)
 (* |honda_(select #length main_~tmp~3.base)| (- 1))
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 1)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base (- 1)) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1281 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| (- 1))
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1280 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 1) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base (- 1)) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 1) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset (- 1))
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 1) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset (- 1)) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 1) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base (- 1))
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (* aux_1281 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 1)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| (- 1))
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 1)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 1)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc10.offset| 0)
 (* |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* honda_main_~id~2.offset 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_(ite main_#t~short9 1 0)| 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)| 0)
 (* |honda_(select old(#length) main_~tmp~3.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_(ite (select #valid main_~tmp~3.base) 1 0)| 0)
 (* |honda_main_#t~mem7| 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem8| 0) 
 (* honda_main_~tmp~3.base 0) 
 (* |honda_main_#t~malloc1.base| 0)
 (* |honda_(select old(#length) main_~id~2.base)| 0)
 (* |honda_(select #length main_~id~2.base)| 0) 
 (* |honda_main_#t~nondet2| 0) 
 (* |honda_main_#t~mem11| 0) 
 (* |honda_main_#t~mem16| 0)
 (*
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~mem13| 0)
 (* |honda_(select #length main_~maxId~2.base)| 0)
 (* |honda_main_#t~mem18| 0) 
 (* honda_main_~maxId~2.offset (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 0) (* |honda_main_#t~malloc10.base| 0)
 (* |honda_(ite (select old(#valid) main_~id~2.base) 1 0)| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_(select old(#length) main_~maxId~2.base)| 0)
 (* |honda_main_#t~nondet4| 0) 
 (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* honda_main_~maxId~2.base 0) 
 (* honda_main_~id~2.base 0)
 (* |honda_(ite (select #valid main_~maxId~2.base) 1 0)| 0)
 (* |honda_#NULL.offset| 0) 
 (* |honda_(select #length main_~tmp~3.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~tmp~3.offset 0)
 (* |honda_(ite (select #valid main_~id~2.base) 1 0)| 0)
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc10.offset| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~id~2.offset 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_(ite main_#t~short9 1 0)| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* |init_main_#t~mem7| 0) 
 (* |init_main_#t~mem8| 0) 
 (* init_main_~tmp~3.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet2| 0) 
 (* |init_main_#t~mem11| 0) 
 (* |init_main_#t~mem16| 0) 
 (* |init_main_#t~mem13| 0) 
 (* init_main_~maxId~2.offset 0) 
 (* |init_main_#t~malloc10.base| 0) 
 (* |init_main_#t~nondet4| 0) 
 (* |init_main_#t~nondet15| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem14| 0) 
 (* init_main_~maxId~2.base 0) 
 (* init_main_~id~2.base 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~tmp~3.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)))
 (or
 (and
 (= |honda_main_#t~malloc10.offset|
 (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|))
 (= honda_main_~id~2.offset
 (+ honda_main_~id~2.offset ray_main_~id~2.offset))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite main_#t~short9 1 0)|
 (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|))
 (= |honda_main_#t~mem6| (+ |honda_main_#t~mem6| |ray_main_#t~mem6|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select old(#length) main_~tmp~3.base)|
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|))
 (= |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|))
 (= |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|))
 (= |honda_main_#t~mem7| (+ |honda_main_#t~mem7| |ray_main_#t~mem7|))
 (= |honda_main_#t~mem8| (+ |honda_main_#t~mem8| |ray_main_#t~mem8|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~tmp~3.base (+ honda_main_~tmp~3.base ray_main_~tmp~3.base))
 (= |honda_(select old(#length) main_~id~2.base)|
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|))
 (= |honda_main_#t~nondet2|
 (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|))
 (= |honda_(select #length main_~id~2.base)|
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|))
 (= |honda_main_#t~mem11| (+ |honda_main_#t~mem11| |ray_main_#t~mem11|))
 (=
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|))
 (= |honda_(select #length main_~maxId~2.base)|
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|))
 (= honda_main_~maxId~2.offset
 (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|))
 (= |honda_main_#t~malloc10.base|
 (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|))
 (= |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~maxId~2.base)|
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|))
 (= |honda_main_#t~nondet4|
 (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|))
 (= honda_main_~maxId~2.base
 (+ honda_main_~maxId~2.base ray_main_~maxId~2.base))
 (= honda_main_~id~2.base (+ honda_main_~id~2.base ray_main_~id~2.base))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|))
 (= |honda_(select #length main_~tmp~3.base)|
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~tmp~3.offset
 (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset))
 (= |honda_(ite (select #valid main_~id~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 1)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 1)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 1)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) (- 1))
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 1) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 1)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 1)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc10.offset| (* |ray_main_#t~malloc10.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda))
 (= ray_main_~id~2.offset (* ray_main_~id~2.offset lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite main_#t~short9 1 0)| (* |ray_(ite main_#t~short9 1 0)| lambda))
 (= |ray_main_#t~mem6| (* |ray_main_#t~mem6| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select old(#length) main_~tmp~3.base)|
 (* |ray_(select old(#length) main_~tmp~3.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda))
 (= |ray_main_#t~mem7| (* |ray_main_#t~mem7| lambda))
 (= |ray_main_#t~mem8| (* |ray_main_#t~mem8| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~tmp~3.base (* ray_main_~tmp~3.base lambda))
 (= |ray_(select old(#length) main_~id~2.base)|
 (* |ray_(select old(#length) main_~id~2.base)| lambda))
 (= |ray_main_#t~nondet2| (* |ray_main_#t~nondet2| lambda))
 (= |ray_(select #length main_~id~2.base)|
 (* |ray_(select #length main_~id~2.base)| lambda))
 (= |ray_main_#t~mem11| (* |ray_main_#t~mem11| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda))
 (= |ray_(select #length main_~maxId~2.base)|
 (* |ray_(select #length main_~maxId~2.base)| lambda))
 (= ray_main_~maxId~2.offset (* ray_main_~maxId~2.offset lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda))
 (= |ray_main_#t~malloc10.base| (* |ray_main_#t~malloc10.base| lambda))
 (= |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~maxId~2.base)|
 (* |ray_(select old(#length) main_~maxId~2.base)| lambda))
 (= |ray_main_#t~nondet4| (* |ray_main_#t~nondet4| lambda))
 (= ray_main_~maxId~2.base (* ray_main_~maxId~2.base lambda))
 (= ray_main_~id~2.base (* ray_main_~id~2.base lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select #valid main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~tmp~3.base)|
 (* |ray_(select #length main_~tmp~3.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~tmp~3.offset (* ray_main_~tmp~3.offset lambda))
 (= |ray_(ite (select #valid main_~id~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 1)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 1)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 1) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* ray_main_~id~2.base lambda) (- 1)) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 1)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* ray_main_~maxId~2.base lambda) (- 1))
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 1) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc10.offset|
 (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|))
 (= honda_main_~id~2.offset
 (+ honda_main_~id~2.offset ray_main_~id~2.offset))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite main_#t~short9 1 0)|
 (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|))
 (= |honda_main_#t~mem6| (+ |honda_main_#t~mem6| |ray_main_#t~mem6|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select old(#length) main_~tmp~3.base)|
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|))
 (= |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|))
 (= |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|))
 (= |honda_main_#t~mem7| (+ |honda_main_#t~mem7| |ray_main_#t~mem7|))
 (= |honda_main_#t~mem8| (+ |honda_main_#t~mem8| |ray_main_#t~mem8|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~tmp~3.base (+ honda_main_~tmp~3.base ray_main_~tmp~3.base))
 (= |honda_(select old(#length) main_~id~2.base)|
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|))
 (= |honda_main_#t~nondet2|
 (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|))
 (= |honda_(select #length main_~id~2.base)|
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|))
 (= |honda_main_#t~mem11| (+ |honda_main_#t~mem11| |ray_main_#t~mem11|))
 (=
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|))
 (= |honda_(select #length main_~maxId~2.base)|
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|))
 (= honda_main_~maxId~2.offset
 (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|))
 (= |honda_main_#t~malloc10.base|
 (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|))
 (= |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~maxId~2.base)|
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|))
 (= |honda_main_#t~nondet4|
 (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|))
 (= honda_main_~maxId~2.base
 (+ honda_main_~maxId~2.base ray_main_~maxId~2.base))
 (= honda_main_~id~2.base (+ honda_main_~id~2.base ray_main_~id~2.base))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|))
 (= |honda_(select #length main_~tmp~3.base)|
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~tmp~3.offset
 (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset))
 (= |honda_(ite (select #valid main_~id~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 1)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) (- 1))
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 1)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 1) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 1)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 1)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc10.offset| (* |ray_main_#t~malloc10.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda))
 (= ray_main_~id~2.offset (* ray_main_~id~2.offset lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite main_#t~short9 1 0)| (* |ray_(ite main_#t~short9 1 0)| lambda))
 (= |ray_main_#t~mem6| (* |ray_main_#t~mem6| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select old(#length) main_~tmp~3.base)|
 (* |ray_(select old(#length) main_~tmp~3.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda))
 (= |ray_main_#t~mem7| (* |ray_main_#t~mem7| lambda))
 (= |ray_main_#t~mem8| (* |ray_main_#t~mem8| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~tmp~3.base (* ray_main_~tmp~3.base lambda))
 (= |ray_(select old(#length) main_~id~2.base)|
 (* |ray_(select old(#length) main_~id~2.base)| lambda))
 (= |ray_main_#t~nondet2| (* |ray_main_#t~nondet2| lambda))
 (= |ray_(select #length main_~id~2.base)|
 (* |ray_(select #length main_~id~2.base)| lambda))
 (= |ray_main_#t~mem11| (* |ray_main_#t~mem11| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda))
 (= |ray_(select #length main_~maxId~2.base)|
 (* |ray_(select #length main_~maxId~2.base)| lambda))
 (= ray_main_~maxId~2.offset (* ray_main_~maxId~2.offset lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda))
 (= |ray_main_#t~malloc10.base| (* |ray_main_#t~malloc10.base| lambda))
 (= |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~maxId~2.base)|
 (* |ray_(select old(#length) main_~maxId~2.base)| lambda))
 (= |ray_main_#t~nondet4| (* |ray_main_#t~nondet4| lambda))
 (= ray_main_~maxId~2.base (* ray_main_~maxId~2.base lambda))
 (= ray_main_~id~2.base (* ray_main_~id~2.base lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select #valid main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~tmp~3.base)|
 (* |ray_(select #length main_~tmp~3.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~tmp~3.offset (* ray_main_~tmp~3.offset lambda))
 (= |ray_(ite (select #valid main_~id~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 1)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) (- 1))
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 1) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 1)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 1) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* ray_main_~id~2.base lambda) (- 1)) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 1) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc10.offset|
 (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|))
 (= honda_main_~id~2.offset
 (+ honda_main_~id~2.offset ray_main_~id~2.offset))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite main_#t~short9 1 0)|
 (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|))
 (= |honda_main_#t~mem6| (+ |honda_main_#t~mem6| |ray_main_#t~mem6|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select old(#length) main_~tmp~3.base)|
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|))
 (= |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|))
 (= |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|))
 (= |honda_main_#t~mem7| (+ |honda_main_#t~mem7| |ray_main_#t~mem7|))
 (= |honda_main_#t~mem8| (+ |honda_main_#t~mem8| |ray_main_#t~mem8|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~tmp~3.base (+ honda_main_~tmp~3.base ray_main_~tmp~3.base))
 (= |honda_(select old(#length) main_~id~2.base)|
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|))
 (= |honda_main_#t~nondet2|
 (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|))
 (= |honda_(select #length main_~id~2.base)|
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|))
 (= |honda_main_#t~mem11| (+ |honda_main_#t~mem11| |ray_main_#t~mem11|))
 (=
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|))
 (= |honda_(select #length main_~maxId~2.base)|
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|))
 (= honda_main_~maxId~2.offset
 (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|))
 (= |honda_main_#t~malloc10.base|
 (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|))
 (= |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~maxId~2.base)|
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|))
 (= |honda_main_#t~nondet4|
 (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|))
 (= honda_main_~maxId~2.base
 (+ honda_main_~maxId~2.base ray_main_~maxId~2.base))
 (= honda_main_~id~2.base (+ honda_main_~id~2.base ray_main_~id~2.base))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|))
 (= |honda_(select #length main_~tmp~3.base)|
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~tmp~3.offset
 (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset))
 (= |honda_(ite (select #valid main_~id~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 1)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) (- 1))
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 1)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 1) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 1)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 1)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 1)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc10.offset| (* |ray_main_#t~malloc10.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda))
 (= ray_main_~id~2.offset (* ray_main_~id~2.offset lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite main_#t~short9 1 0)| (* |ray_(ite main_#t~short9 1 0)| lambda))
 (= |ray_main_#t~mem6| (* |ray_main_#t~mem6| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select old(#length) main_~tmp~3.base)|
 (* |ray_(select old(#length) main_~tmp~3.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda))
 (= |ray_main_#t~mem7| (* |ray_main_#t~mem7| lambda))
 (= |ray_main_#t~mem8| (* |ray_main_#t~mem8| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~tmp~3.base (* ray_main_~tmp~3.base lambda))
 (= |ray_(select old(#length) main_~id~2.base)|
 (* |ray_(select old(#length) main_~id~2.base)| lambda))
 (= |ray_main_#t~nondet2| (* |ray_main_#t~nondet2| lambda))
 (= |ray_(select #length main_~id~2.base)|
 (* |ray_(select #length main_~id~2.base)| lambda))
 (= |ray_main_#t~mem11| (* |ray_main_#t~mem11| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda))
 (= |ray_(select #length main_~maxId~2.base)|
 (* |ray_(select #length main_~maxId~2.base)| lambda))
 (= ray_main_~maxId~2.offset (* ray_main_~maxId~2.offset lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda))
 (= |ray_main_#t~malloc10.base| (* |ray_main_#t~malloc10.base| lambda))
 (= |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~maxId~2.base)|
 (* |ray_(select old(#length) main_~maxId~2.base)| lambda))
 (= |ray_main_#t~nondet4| (* |ray_main_#t~nondet4| lambda))
 (= ray_main_~maxId~2.base (* ray_main_~maxId~2.base lambda))
 (= ray_main_~id~2.base (* ray_main_~id~2.base lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select #valid main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~tmp~3.base)|
 (* |ray_(select #length main_~tmp~3.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~tmp~3.offset (* ray_main_~tmp~3.offset lambda))
 (= |ray_(ite (select #valid main_~id~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 1)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 1)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) (- 1))
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 1) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 1) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 1)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* ray_main_~id~2.base lambda) (- 1)) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc10.offset|
 (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|))
 (= honda_main_~id~2.offset
 (+ honda_main_~id~2.offset ray_main_~id~2.offset))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite main_#t~short9 1 0)|
 (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|))
 (= |honda_main_#t~mem6| (+ |honda_main_#t~mem6| |ray_main_#t~mem6|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select old(#length) main_~tmp~3.base)|
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|))
 (= |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|))
 (= |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|))
 (= |honda_main_#t~mem7| (+ |honda_main_#t~mem7| |ray_main_#t~mem7|))
 (= |honda_main_#t~mem8| (+ |honda_main_#t~mem8| |ray_main_#t~mem8|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~tmp~3.base (+ honda_main_~tmp~3.base ray_main_~tmp~3.base))
 (= |honda_(select old(#length) main_~id~2.base)|
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|))
 (= |honda_main_#t~nondet2|
 (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|))
 (= |honda_(select #length main_~id~2.base)|
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|))
 (= |honda_main_#t~mem11| (+ |honda_main_#t~mem11| |ray_main_#t~mem11|))
 (=
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|))
 (= |honda_(select #length main_~maxId~2.base)|
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|))
 (= honda_main_~maxId~2.offset
 (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|))
 (= |honda_main_#t~malloc10.base|
 (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|))
 (= |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~maxId~2.base)|
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|))
 (= |honda_main_#t~nondet4|
 (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|))
 (= honda_main_~maxId~2.base
 (+ honda_main_~maxId~2.base ray_main_~maxId~2.base))
 (= honda_main_~id~2.base (+ honda_main_~id~2.base ray_main_~id~2.base))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|))
 (= |honda_(select #length main_~tmp~3.base)|
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~tmp~3.offset
 (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset))
 (= |honda_(ite (select #valid main_~id~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 1)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) (- 1))
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 1)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 1) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 1)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 1)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc10.offset| (* |ray_main_#t~malloc10.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda))
 (= ray_main_~id~2.offset (* ray_main_~id~2.offset lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite main_#t~short9 1 0)| (* |ray_(ite main_#t~short9 1 0)| lambda))
 (= |ray_main_#t~mem6| (* |ray_main_#t~mem6| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select old(#length) main_~tmp~3.base)|
 (* |ray_(select old(#length) main_~tmp~3.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda))
 (= |ray_main_#t~mem7| (* |ray_main_#t~mem7| lambda))
 (= |ray_main_#t~mem8| (* |ray_main_#t~mem8| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~tmp~3.base (* ray_main_~tmp~3.base lambda))
 (= |ray_(select old(#length) main_~id~2.base)|
 (* |ray_(select old(#length) main_~id~2.base)| lambda))
 (= |ray_main_#t~nondet2| (* |ray_main_#t~nondet2| lambda))
 (= |ray_(select #length main_~id~2.base)|
 (* |ray_(select #length main_~id~2.base)| lambda))
 (= |ray_main_#t~mem11| (* |ray_main_#t~mem11| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda))
 (= |ray_(select #length main_~maxId~2.base)|
 (* |ray_(select #length main_~maxId~2.base)| lambda))
 (= ray_main_~maxId~2.offset (* ray_main_~maxId~2.offset lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda))
 (= |ray_main_#t~malloc10.base| (* |ray_main_#t~malloc10.base| lambda))
 (= |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~maxId~2.base)|
 (* |ray_(select old(#length) main_~maxId~2.base)| lambda))
 (= |ray_main_#t~nondet4| (* |ray_main_#t~nondet4| lambda))
 (= ray_main_~maxId~2.base (* ray_main_~maxId~2.base lambda))
 (= ray_main_~id~2.base (* ray_main_~id~2.base lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select #valid main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~tmp~3.base)|
 (* |ray_(select #length main_~tmp~3.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~tmp~3.offset (* ray_main_~tmp~3.offset lambda))
 (= |ray_(ite (select #valid main_~id~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 1)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) (- 1))
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 1) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 1)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 1) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* ray_main_~id~2.base lambda) (- 1)) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 1) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc10.offset|
 (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|))
 (= honda_main_~id~2.offset
 (+ honda_main_~id~2.offset ray_main_~id~2.offset))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite main_#t~short9 1 0)|
 (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|))
 (= |honda_main_#t~mem6| (+ |honda_main_#t~mem6| |ray_main_#t~mem6|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select old(#length) main_~tmp~3.base)|
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|))
 (= |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|))
 (= |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|))
 (= |honda_main_#t~mem7| (+ |honda_main_#t~mem7| |ray_main_#t~mem7|))
 (= |honda_main_#t~mem8| (+ |honda_main_#t~mem8| |ray_main_#t~mem8|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~tmp~3.base (+ honda_main_~tmp~3.base ray_main_~tmp~3.base))
 (= |honda_(select old(#length) main_~id~2.base)|
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|))
 (= |honda_main_#t~nondet2|
 (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|))
 (= |honda_(select #length main_~id~2.base)|
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|))
 (= |honda_main_#t~mem11| (+ |honda_main_#t~mem11| |ray_main_#t~mem11|))
 (=
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|))
 (= |honda_(select #length main_~maxId~2.base)|
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|))
 (= honda_main_~maxId~2.offset
 (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|))
 (= |honda_main_#t~malloc10.base|
 (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|))
 (= |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~maxId~2.base)|
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|))
 (= |honda_main_#t~nondet4|
 (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|))
 (= honda_main_~maxId~2.base
 (+ honda_main_~maxId~2.base ray_main_~maxId~2.base))
 (= honda_main_~id~2.base (+ honda_main_~id~2.base ray_main_~id~2.base))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|))
 (= |honda_(select #length main_~tmp~3.base)|
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~tmp~3.offset
 (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset))
 (= |honda_(ite (select #valid main_~id~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 1)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) (- 1))
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 1) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 1)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 1)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 1)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc10.offset| (* |ray_main_#t~malloc10.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda))
 (= ray_main_~id~2.offset (* ray_main_~id~2.offset lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite main_#t~short9 1 0)| (* |ray_(ite main_#t~short9 1 0)| lambda))
 (= |ray_main_#t~mem6| (* |ray_main_#t~mem6| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select old(#length) main_~tmp~3.base)|
 (* |ray_(select old(#length) main_~tmp~3.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda))
 (= |ray_main_#t~mem7| (* |ray_main_#t~mem7| lambda))
 (= |ray_main_#t~mem8| (* |ray_main_#t~mem8| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~tmp~3.base (* ray_main_~tmp~3.base lambda))
 (= |ray_(select old(#length) main_~id~2.base)|
 (* |ray_(select old(#length) main_~id~2.base)| lambda))
 (= |ray_main_#t~nondet2| (* |ray_main_#t~nondet2| lambda))
 (= |ray_(select #length main_~id~2.base)|
 (* |ray_(select #length main_~id~2.base)| lambda))
 (= |ray_main_#t~mem11| (* |ray_main_#t~mem11| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda))
 (= |ray_(select #length main_~maxId~2.base)|
 (* |ray_(select #length main_~maxId~2.base)| lambda))
 (= ray_main_~maxId~2.offset (* ray_main_~maxId~2.offset lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda))
 (= |ray_main_#t~malloc10.base| (* |ray_main_#t~malloc10.base| lambda))
 (= |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~maxId~2.base)|
 (* |ray_(select old(#length) main_~maxId~2.base)| lambda))
 (= |ray_main_#t~nondet4| (* |ray_main_#t~nondet4| lambda))
 (= ray_main_~maxId~2.base (* ray_main_~maxId~2.base lambda))
 (= ray_main_~id~2.base (* ray_main_~id~2.base lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select #valid main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~tmp~3.base)|
 (* |ray_(select #length main_~tmp~3.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~tmp~3.offset (* ray_main_~tmp~3.offset lambda))
 (= |ray_(ite (select #valid main_~id~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 1)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* ray_main_~maxId~2.base lambda) (- 1))
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 1) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 1)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 1) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 1)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* ray_main_~id~2.base lambda) (- 1)) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc10.offset|
 (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|))
 (= honda_main_~id~2.offset
 (+ honda_main_~id~2.offset ray_main_~id~2.offset))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite main_#t~short9 1 0)|
 (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|))
 (= |honda_main_#t~mem6| (+ |honda_main_#t~mem6| |ray_main_#t~mem6|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select old(#length) main_~tmp~3.base)|
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|))
 (= |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|))
 (= |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|))
 (= |honda_main_#t~mem7| (+ |honda_main_#t~mem7| |ray_main_#t~mem7|))
 (= |honda_main_#t~mem8| (+ |honda_main_#t~mem8| |ray_main_#t~mem8|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~tmp~3.base (+ honda_main_~tmp~3.base ray_main_~tmp~3.base))
 (= |honda_(select old(#length) main_~id~2.base)|
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|))
 (= |honda_main_#t~nondet2|
 (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|))
 (= |honda_(select #length main_~id~2.base)|
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|))
 (= |honda_main_#t~mem11| (+ |honda_main_#t~mem11| |ray_main_#t~mem11|))
 (=
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|))
 (= |honda_(select #length main_~maxId~2.base)|
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|))
 (= honda_main_~maxId~2.offset
 (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|))
 (= |honda_main_#t~malloc10.base|
 (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|))
 (= |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~maxId~2.base)|
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|))
 (= |honda_main_#t~nondet4|
 (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|))
 (= honda_main_~maxId~2.base
 (+ honda_main_~maxId~2.base ray_main_~maxId~2.base))
 (= honda_main_~id~2.base (+ honda_main_~id~2.base ray_main_~id~2.base))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|))
 (= |honda_(select #length main_~tmp~3.base)|
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~tmp~3.offset
 (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset))
 (= |honda_(ite (select #valid main_~id~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 1)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) (- 1))
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) (- 1))
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 1)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 1) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 1)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 1)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc10.offset| (* |ray_main_#t~malloc10.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda))
 (= ray_main_~id~2.offset (* ray_main_~id~2.offset lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite main_#t~short9 1 0)| (* |ray_(ite main_#t~short9 1 0)| lambda))
 (= |ray_main_#t~mem6| (* |ray_main_#t~mem6| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select old(#length) main_~tmp~3.base)|
 (* |ray_(select old(#length) main_~tmp~3.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda))
 (= |ray_main_#t~mem7| (* |ray_main_#t~mem7| lambda))
 (= |ray_main_#t~mem8| (* |ray_main_#t~mem8| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~tmp~3.base (* ray_main_~tmp~3.base lambda))
 (= |ray_(select old(#length) main_~id~2.base)|
 (* |ray_(select old(#length) main_~id~2.base)| lambda))
 (= |ray_main_#t~nondet2| (* |ray_main_#t~nondet2| lambda))
 (= |ray_(select #length main_~id~2.base)|
 (* |ray_(select #length main_~id~2.base)| lambda))
 (= |ray_main_#t~mem11| (* |ray_main_#t~mem11| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda))
 (= |ray_(select #length main_~maxId~2.base)|
 (* |ray_(select #length main_~maxId~2.base)| lambda))
 (= ray_main_~maxId~2.offset (* ray_main_~maxId~2.offset lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda))
 (= |ray_main_#t~malloc10.base| (* |ray_main_#t~malloc10.base| lambda))
 (= |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~maxId~2.base)|
 (* |ray_(select old(#length) main_~maxId~2.base)| lambda))
 (= |ray_main_#t~nondet4| (* |ray_main_#t~nondet4| lambda))
 (= ray_main_~maxId~2.base (* ray_main_~maxId~2.base lambda))
 (= ray_main_~id~2.base (* ray_main_~id~2.base lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select #valid main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~tmp~3.base)|
 (* |ray_(select #length main_~tmp~3.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~tmp~3.offset (* ray_main_~tmp~3.offset lambda))
 (= |ray_(ite (select #valid main_~id~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 1)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* ray_main_~maxId~2.base lambda) (- 1))
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 1) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 1)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) (- 1))
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 1) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 1) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc10.offset|
 (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|))
 (= honda_main_~id~2.offset
 (+ honda_main_~id~2.offset ray_main_~id~2.offset))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite main_#t~short9 1 0)|
 (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|))
 (= |honda_main_#t~mem6| (+ |honda_main_#t~mem6| |ray_main_#t~mem6|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select old(#length) main_~tmp~3.base)|
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|))
 (= |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|))
 (= |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|))
 (= |honda_main_#t~mem7| (+ |honda_main_#t~mem7| |ray_main_#t~mem7|))
 (= |honda_main_#t~mem8| (+ |honda_main_#t~mem8| |ray_main_#t~mem8|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~tmp~3.base (+ honda_main_~tmp~3.base ray_main_~tmp~3.base))
 (= |honda_(select old(#length) main_~id~2.base)|
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|))
 (= |honda_main_#t~nondet2|
 (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|))
 (= |honda_(select #length main_~id~2.base)|
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|))
 (= |honda_main_#t~mem11| (+ |honda_main_#t~mem11| |ray_main_#t~mem11|))
 (=
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|))
 (= |honda_(select #length main_~maxId~2.base)|
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|))
 (= honda_main_~maxId~2.offset
 (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|))
 (= |honda_main_#t~malloc10.base|
 (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|))
 (= |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~maxId~2.base)|
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|))
 (= |honda_main_#t~nondet4|
 (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|))
 (= honda_main_~maxId~2.base
 (+ honda_main_~maxId~2.base ray_main_~maxId~2.base))
 (= honda_main_~id~2.base (+ honda_main_~id~2.base ray_main_~id~2.base))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|))
 (= |honda_(select #length main_~tmp~3.base)|
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~tmp~3.offset
 (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset))
 (= |honda_(ite (select #valid main_~id~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 1)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) (- 1))
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 1)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 1)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| (- 1)) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 1)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc10.offset| (* |ray_main_#t~malloc10.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda))
 (= ray_main_~id~2.offset (* ray_main_~id~2.offset lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite main_#t~short9 1 0)| (* |ray_(ite main_#t~short9 1 0)| lambda))
 (= |ray_main_#t~mem6| (* |ray_main_#t~mem6| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select old(#length) main_~tmp~3.base)|
 (* |ray_(select old(#length) main_~tmp~3.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda))
 (= |ray_main_#t~mem7| (* |ray_main_#t~mem7| lambda))
 (= |ray_main_#t~mem8| (* |ray_main_#t~mem8| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~tmp~3.base (* ray_main_~tmp~3.base lambda))
 (= |ray_(select old(#length) main_~id~2.base)|
 (* |ray_(select old(#length) main_~id~2.base)| lambda))
 (= |ray_main_#t~nondet2| (* |ray_main_#t~nondet2| lambda))
 (= |ray_(select #length main_~id~2.base)|
 (* |ray_(select #length main_~id~2.base)| lambda))
 (= |ray_main_#t~mem11| (* |ray_main_#t~mem11| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda))
 (= |ray_(select #length main_~maxId~2.base)|
 (* |ray_(select #length main_~maxId~2.base)| lambda))
 (= ray_main_~maxId~2.offset (* ray_main_~maxId~2.offset lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda))
 (= |ray_main_#t~malloc10.base| (* |ray_main_#t~malloc10.base| lambda))
 (= |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~maxId~2.base)|
 (* |ray_(select old(#length) main_~maxId~2.base)| lambda))
 (= |ray_main_#t~nondet4| (* |ray_main_#t~nondet4| lambda))
 (= ray_main_~maxId~2.base (* ray_main_~maxId~2.base lambda))
 (= ray_main_~id~2.base (* ray_main_~id~2.base lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select #valid main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~tmp~3.base)|
 (* |ray_(select #length main_~tmp~3.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~tmp~3.offset (* ray_main_~tmp~3.offset lambda))
 (= |ray_(ite (select #valid main_~id~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 1)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* ray_main_~maxId~2.base lambda) (- 1))
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 1) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 1)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 1)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* ray_main_~id~2.base lambda) (- 1)) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| (- 1)) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc10.offset|
 (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|))
 (= honda_main_~id~2.offset
 (+ honda_main_~id~2.offset ray_main_~id~2.offset))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite main_#t~short9 1 0)|
 (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|))
 (= |honda_main_#t~mem6| (+ |honda_main_#t~mem6| |ray_main_#t~mem6|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select old(#length) main_~tmp~3.base)|
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|))
 (= |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|))
 (= |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|))
 (= |honda_main_#t~mem7| (+ |honda_main_#t~mem7| |ray_main_#t~mem7|))
 (= |honda_main_#t~mem8| (+ |honda_main_#t~mem8| |ray_main_#t~mem8|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~tmp~3.base (+ honda_main_~tmp~3.base ray_main_~tmp~3.base))
 (= |honda_(select old(#length) main_~id~2.base)|
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|))
 (= |honda_main_#t~nondet2|
 (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|))
 (= |honda_(select #length main_~id~2.base)|
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|))
 (= |honda_main_#t~mem11| (+ |honda_main_#t~mem11| |ray_main_#t~mem11|))
 (=
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|))
 (= |honda_(select #length main_~maxId~2.base)|
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|))
 (= honda_main_~maxId~2.offset
 (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|))
 (= |honda_main_#t~malloc10.base|
 (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|))
 (= |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~maxId~2.base)|
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|))
 (= |honda_main_#t~nondet4|
 (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|))
 (= honda_main_~maxId~2.base
 (+ honda_main_~maxId~2.base ray_main_~maxId~2.base))
 (= honda_main_~id~2.base (+ honda_main_~id~2.base ray_main_~id~2.base))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|))
 (= |honda_(select #length main_~tmp~3.base)|
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~tmp~3.offset
 (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset))
 (= |honda_(ite (select #valid main_~id~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 1)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) (- 1))
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 1)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 1)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| (- 1)) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 1)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc10.offset| (* |ray_main_#t~malloc10.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda))
 (= ray_main_~id~2.offset (* ray_main_~id~2.offset lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite main_#t~short9 1 0)| (* |ray_(ite main_#t~short9 1 0)| lambda))
 (= |ray_main_#t~mem6| (* |ray_main_#t~mem6| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select old(#length) main_~tmp~3.base)|
 (* |ray_(select old(#length) main_~tmp~3.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda))
 (= |ray_main_#t~mem7| (* |ray_main_#t~mem7| lambda))
 (= |ray_main_#t~mem8| (* |ray_main_#t~mem8| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~tmp~3.base (* ray_main_~tmp~3.base lambda))
 (= |ray_(select old(#length) main_~id~2.base)|
 (* |ray_(select old(#length) main_~id~2.base)| lambda))
 (= |ray_main_#t~nondet2| (* |ray_main_#t~nondet2| lambda))
 (= |ray_(select #length main_~id~2.base)|
 (* |ray_(select #length main_~id~2.base)| lambda))
 (= |ray_main_#t~mem11| (* |ray_main_#t~mem11| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda))
 (= |ray_(select #length main_~maxId~2.base)|
 (* |ray_(select #length main_~maxId~2.base)| lambda))
 (= ray_main_~maxId~2.offset (* ray_main_~maxId~2.offset lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda))
 (= |ray_main_#t~malloc10.base| (* |ray_main_#t~malloc10.base| lambda))
 (= |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~maxId~2.base)|
 (* |ray_(select old(#length) main_~maxId~2.base)| lambda))
 (= |ray_main_#t~nondet4| (* |ray_main_#t~nondet4| lambda))
 (= ray_main_~maxId~2.base (* ray_main_~maxId~2.base lambda))
 (= ray_main_~id~2.base (* ray_main_~id~2.base lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select #valid main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~tmp~3.base)|
 (* |ray_(select #length main_~tmp~3.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~tmp~3.offset (* ray_main_~tmp~3.offset lambda))
 (= |ray_(ite (select #valid main_~id~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 1)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) (- 1))
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 1) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 1)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 1) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* ray_main_~id~2.base lambda) (- 1)) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| (- 1)) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc10.offset|
 (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|))
 (= honda_main_~id~2.offset
 (+ honda_main_~id~2.offset ray_main_~id~2.offset))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite main_#t~short9 1 0)|
 (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|))
 (= |honda_main_#t~mem6| (+ |honda_main_#t~mem6| |ray_main_#t~mem6|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select old(#length) main_~tmp~3.base)|
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|))
 (= |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|))
 (= |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|))
 (= |honda_main_#t~mem7| (+ |honda_main_#t~mem7| |ray_main_#t~mem7|))
 (= |honda_main_#t~mem8| (+ |honda_main_#t~mem8| |ray_main_#t~mem8|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~tmp~3.base (+ honda_main_~tmp~3.base ray_main_~tmp~3.base))
 (= |honda_(select old(#length) main_~id~2.base)|
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|))
 (= |honda_main_#t~nondet2|
 (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|))
 (= |honda_(select #length main_~id~2.base)|
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|))
 (= |honda_main_#t~mem11| (+ |honda_main_#t~mem11| |ray_main_#t~mem11|))
 (=
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|))
 (= |honda_(select #length main_~maxId~2.base)|
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|))
 (= honda_main_~maxId~2.offset
 (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|))
 (= |honda_main_#t~malloc10.base|
 (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|))
 (= |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~maxId~2.base)|
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|))
 (= |honda_main_#t~nondet4|
 (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|))
 (= honda_main_~maxId~2.base
 (+ honda_main_~maxId~2.base ray_main_~maxId~2.base))
 (= honda_main_~id~2.base (+ honda_main_~id~2.base ray_main_~id~2.base))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|))
 (= |honda_(select #length main_~tmp~3.base)|
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~tmp~3.offset
 (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset))
 (= |honda_(ite (select #valid main_~id~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 1)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) (- 1))
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) (- 1))
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 1)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 1) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 1)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 1)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc10.offset| (* |ray_main_#t~malloc10.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda))
 (= ray_main_~id~2.offset (* ray_main_~id~2.offset lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite main_#t~short9 1 0)| (* |ray_(ite main_#t~short9 1 0)| lambda))
 (= |ray_main_#t~mem6| (* |ray_main_#t~mem6| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select old(#length) main_~tmp~3.base)|
 (* |ray_(select old(#length) main_~tmp~3.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda))
 (= |ray_main_#t~mem7| (* |ray_main_#t~mem7| lambda))
 (= |ray_main_#t~mem8| (* |ray_main_#t~mem8| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~tmp~3.base (* ray_main_~tmp~3.base lambda))
 (= |ray_(select old(#length) main_~id~2.base)|
 (* |ray_(select old(#length) main_~id~2.base)| lambda))
 (= |ray_main_#t~nondet2| (* |ray_main_#t~nondet2| lambda))
 (= |ray_(select #length main_~id~2.base)|
 (* |ray_(select #length main_~id~2.base)| lambda))
 (= |ray_main_#t~mem11| (* |ray_main_#t~mem11| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda))
 (= |ray_(select #length main_~maxId~2.base)|
 (* |ray_(select #length main_~maxId~2.base)| lambda))
 (= ray_main_~maxId~2.offset (* ray_main_~maxId~2.offset lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda))
 (= |ray_main_#t~malloc10.base| (* |ray_main_#t~malloc10.base| lambda))
 (= |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~maxId~2.base)|
 (* |ray_(select old(#length) main_~maxId~2.base)| lambda))
 (= |ray_main_#t~nondet4| (* |ray_main_#t~nondet4| lambda))
 (= ray_main_~maxId~2.base (* ray_main_~maxId~2.base lambda))
 (= ray_main_~id~2.base (* ray_main_~id~2.base lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select #valid main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~tmp~3.base)|
 (* |ray_(select #length main_~tmp~3.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~tmp~3.offset (* ray_main_~tmp~3.offset lambda))
 (= |ray_(ite (select #valid main_~id~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 1)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* ray_main_~maxId~2.base lambda) (- 1))
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 1) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 1)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) (- 1))
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 1) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 1) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc10.offset|
 (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|))
 (= honda_main_~id~2.offset
 (+ honda_main_~id~2.offset ray_main_~id~2.offset))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite main_#t~short9 1 0)|
 (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|))
 (= |honda_main_#t~mem6| (+ |honda_main_#t~mem6| |ray_main_#t~mem6|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select old(#length) main_~tmp~3.base)|
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|))
 (= |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|))
 (= |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|))
 (= |honda_main_#t~mem7| (+ |honda_main_#t~mem7| |ray_main_#t~mem7|))
 (= |honda_main_#t~mem8| (+ |honda_main_#t~mem8| |ray_main_#t~mem8|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~tmp~3.base (+ honda_main_~tmp~3.base ray_main_~tmp~3.base))
 (= |honda_(select old(#length) main_~id~2.base)|
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|))
 (= |honda_main_#t~nondet2|
 (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|))
 (= |honda_(select #length main_~id~2.base)|
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|))
 (= |honda_main_#t~mem11| (+ |honda_main_#t~mem11| |ray_main_#t~mem11|))
 (=
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|))
 (= |honda_(select #length main_~maxId~2.base)|
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|))
 (= honda_main_~maxId~2.offset
 (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|))
 (= |honda_main_#t~malloc10.base|
 (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|))
 (= |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~maxId~2.base)|
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|))
 (= |honda_main_#t~nondet4|
 (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|))
 (= honda_main_~maxId~2.base
 (+ honda_main_~maxId~2.base ray_main_~maxId~2.base))
 (= honda_main_~id~2.base (+ honda_main_~id~2.base ray_main_~id~2.base))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|))
 (= |honda_(select #length main_~tmp~3.base)|
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~tmp~3.offset
 (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset))
 (= |honda_(ite (select #valid main_~id~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 1)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 1)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 1)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) (- 1))
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 1) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 1)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 1)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc10.offset| (* |ray_main_#t~malloc10.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda))
 (= ray_main_~id~2.offset (* ray_main_~id~2.offset lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite main_#t~short9 1 0)| (* |ray_(ite main_#t~short9 1 0)| lambda))
 (= |ray_main_#t~mem6| (* |ray_main_#t~mem6| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select old(#length) main_~tmp~3.base)|
 (* |ray_(select old(#length) main_~tmp~3.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda))
 (= |ray_main_#t~mem7| (* |ray_main_#t~mem7| lambda))
 (= |ray_main_#t~mem8| (* |ray_main_#t~mem8| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~tmp~3.base (* ray_main_~tmp~3.base lambda))
 (= |ray_(select old(#length) main_~id~2.base)|
 (* |ray_(select old(#length) main_~id~2.base)| lambda))
 (= |ray_main_#t~nondet2| (* |ray_main_#t~nondet2| lambda))
 (= |ray_(select #length main_~id~2.base)|
 (* |ray_(select #length main_~id~2.base)| lambda))
 (= |ray_main_#t~mem11| (* |ray_main_#t~mem11| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda))
 (= |ray_(select #length main_~maxId~2.base)|
 (* |ray_(select #length main_~maxId~2.base)| lambda))
 (= ray_main_~maxId~2.offset (* ray_main_~maxId~2.offset lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda))
 (= |ray_main_#t~malloc10.base| (* |ray_main_#t~malloc10.base| lambda))
 (= |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~maxId~2.base)|
 (* |ray_(select old(#length) main_~maxId~2.base)| lambda))
 (= |ray_main_#t~nondet4| (* |ray_main_#t~nondet4| lambda))
 (= ray_main_~maxId~2.base (* ray_main_~maxId~2.base lambda))
 (= ray_main_~id~2.base (* ray_main_~id~2.base lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select #valid main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~tmp~3.base)|
 (* |ray_(select #length main_~tmp~3.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~tmp~3.offset (* ray_main_~tmp~3.offset lambda))
 (= |ray_(ite (select #valid main_~id~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 1)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 1)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 1) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* ray_main_~id~2.base lambda) (- 1)) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 1)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* ray_main_~maxId~2.base lambda) (- 1))
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 1) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc10.offset|
 (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|))
 (= honda_main_~id~2.offset
 (+ honda_main_~id~2.offset ray_main_~id~2.offset))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite main_#t~short9 1 0)|
 (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|))
 (= |honda_main_#t~mem6| (+ |honda_main_#t~mem6| |ray_main_#t~mem6|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select old(#length) main_~tmp~3.base)|
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|))
 (= |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|))
 (= |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|))
 (= |honda_main_#t~mem7| (+ |honda_main_#t~mem7| |ray_main_#t~mem7|))
 (= |honda_main_#t~mem8| (+ |honda_main_#t~mem8| |ray_main_#t~mem8|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~tmp~3.base (+ honda_main_~tmp~3.base ray_main_~tmp~3.base))
 (= |honda_(select old(#length) main_~id~2.base)|
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|))
 (= |honda_main_#t~nondet2|
 (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|))
 (= |honda_(select #length main_~id~2.base)|
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|))
 (= |honda_main_#t~mem11| (+ |honda_main_#t~mem11| |ray_main_#t~mem11|))
 (=
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|))
 (= |honda_(select #length main_~maxId~2.base)|
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|))
 (= honda_main_~maxId~2.offset
 (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|))
 (= |honda_main_#t~malloc10.base|
 (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|))
 (= |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~maxId~2.base)|
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|))
 (= |honda_main_#t~nondet4|
 (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|))
 (= honda_main_~maxId~2.base
 (+ honda_main_~maxId~2.base ray_main_~maxId~2.base))
 (= honda_main_~id~2.base (+ honda_main_~id~2.base ray_main_~id~2.base))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|))
 (= |honda_(select #length main_~tmp~3.base)|
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~tmp~3.offset
 (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset))
 (= |honda_(ite (select #valid main_~id~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 1)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 1)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 1)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) (- 1))
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 1)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| (- 1)) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 1)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc10.offset| (* |ray_main_#t~malloc10.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda))
 (= ray_main_~id~2.offset (* ray_main_~id~2.offset lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite main_#t~short9 1 0)| (* |ray_(ite main_#t~short9 1 0)| lambda))
 (= |ray_main_#t~mem6| (* |ray_main_#t~mem6| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select old(#length) main_~tmp~3.base)|
 (* |ray_(select old(#length) main_~tmp~3.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda))
 (= |ray_main_#t~mem7| (* |ray_main_#t~mem7| lambda))
 (= |ray_main_#t~mem8| (* |ray_main_#t~mem8| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~tmp~3.base (* ray_main_~tmp~3.base lambda))
 (= |ray_(select old(#length) main_~id~2.base)|
 (* |ray_(select old(#length) main_~id~2.base)| lambda))
 (= |ray_main_#t~nondet2| (* |ray_main_#t~nondet2| lambda))
 (= |ray_(select #length main_~id~2.base)|
 (* |ray_(select #length main_~id~2.base)| lambda))
 (= |ray_main_#t~mem11| (* |ray_main_#t~mem11| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda))
 (= |ray_(select #length main_~maxId~2.base)|
 (* |ray_(select #length main_~maxId~2.base)| lambda))
 (= ray_main_~maxId~2.offset (* ray_main_~maxId~2.offset lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda))
 (= |ray_main_#t~malloc10.base| (* |ray_main_#t~malloc10.base| lambda))
 (= |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~maxId~2.base)|
 (* |ray_(select old(#length) main_~maxId~2.base)| lambda))
 (= |ray_main_#t~nondet4| (* |ray_main_#t~nondet4| lambda))
 (= ray_main_~maxId~2.base (* ray_main_~maxId~2.base lambda))
 (= ray_main_~id~2.base (* ray_main_~id~2.base lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select #valid main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~tmp~3.base)|
 (* |ray_(select #length main_~tmp~3.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~tmp~3.offset (* ray_main_~tmp~3.offset lambda))
 (= |ray_(ite (select #valid main_~id~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 1)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 1)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 1) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* ray_main_~id~2.base lambda) (- 1)) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 1)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* ray_main_~maxId~2.base lambda) (- 1))
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| (- 1)) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc10.offset|
 (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|))
 (= honda_main_~id~2.offset
 (+ honda_main_~id~2.offset ray_main_~id~2.offset))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite main_#t~short9 1 0)|
 (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|))
 (= |honda_main_#t~mem6| (+ |honda_main_#t~mem6| |ray_main_#t~mem6|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select old(#length) main_~tmp~3.base)|
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|))
 (= |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|))
 (= |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|))
 (= |honda_main_#t~mem7| (+ |honda_main_#t~mem7| |ray_main_#t~mem7|))
 (= |honda_main_#t~mem8| (+ |honda_main_#t~mem8| |ray_main_#t~mem8|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~tmp~3.base (+ honda_main_~tmp~3.base ray_main_~tmp~3.base))
 (= |honda_(select old(#length) main_~id~2.base)|
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|))
 (= |honda_main_#t~nondet2|
 (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|))
 (= |honda_(select #length main_~id~2.base)|
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|))
 (= |honda_main_#t~mem11| (+ |honda_main_#t~mem11| |ray_main_#t~mem11|))
 (=
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|))
 (= |honda_(select #length main_~maxId~2.base)|
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|))
 (= honda_main_~maxId~2.offset
 (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|))
 (= |honda_main_#t~malloc10.base|
 (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|))
 (= |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~maxId~2.base)|
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|))
 (= |honda_main_#t~nondet4|
 (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|))
 (= honda_main_~maxId~2.base
 (+ honda_main_~maxId~2.base ray_main_~maxId~2.base))
 (= honda_main_~id~2.base (+ honda_main_~id~2.base ray_main_~id~2.base))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|))
 (= |honda_(select #length main_~tmp~3.base)|
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~tmp~3.offset
 (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset))
 (= |honda_(ite (select #valid main_~id~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 1)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) (- 1))
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 1)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 1)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 1)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| (- 1)) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 1)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc10.offset| (* |ray_main_#t~malloc10.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda))
 (= ray_main_~id~2.offset (* ray_main_~id~2.offset lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite main_#t~short9 1 0)| (* |ray_(ite main_#t~short9 1 0)| lambda))
 (= |ray_main_#t~mem6| (* |ray_main_#t~mem6| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select old(#length) main_~tmp~3.base)|
 (* |ray_(select old(#length) main_~tmp~3.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda))
 (= |ray_main_#t~mem7| (* |ray_main_#t~mem7| lambda))
 (= |ray_main_#t~mem8| (* |ray_main_#t~mem8| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~tmp~3.base (* ray_main_~tmp~3.base lambda))
 (= |ray_(select old(#length) main_~id~2.base)|
 (* |ray_(select old(#length) main_~id~2.base)| lambda))
 (= |ray_main_#t~nondet2| (* |ray_main_#t~nondet2| lambda))
 (= |ray_(select #length main_~id~2.base)|
 (* |ray_(select #length main_~id~2.base)| lambda))
 (= |ray_main_#t~mem11| (* |ray_main_#t~mem11| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda))
 (= |ray_(select #length main_~maxId~2.base)|
 (* |ray_(select #length main_~maxId~2.base)| lambda))
 (= ray_main_~maxId~2.offset (* ray_main_~maxId~2.offset lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda))
 (= |ray_main_#t~malloc10.base| (* |ray_main_#t~malloc10.base| lambda))
 (= |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~maxId~2.base)|
 (* |ray_(select old(#length) main_~maxId~2.base)| lambda))
 (= |ray_main_#t~nondet4| (* |ray_main_#t~nondet4| lambda))
 (= ray_main_~maxId~2.base (* ray_main_~maxId~2.base lambda))
 (= ray_main_~id~2.base (* ray_main_~id~2.base lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select #valid main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~tmp~3.base)|
 (* |ray_(select #length main_~tmp~3.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~tmp~3.offset (* ray_main_~tmp~3.offset lambda))
 (= |ray_(ite (select #valid main_~id~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 1)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 1)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) (- 1))
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 1) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 1)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* ray_main_~id~2.base lambda) (- 1)) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| (- 1)) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc10.offset|
 (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|))
 (= honda_main_~id~2.offset
 (+ honda_main_~id~2.offset ray_main_~id~2.offset))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite main_#t~short9 1 0)|
 (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|))
 (= |honda_main_#t~mem6| (+ |honda_main_#t~mem6| |ray_main_#t~mem6|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select old(#length) main_~tmp~3.base)|
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|))
 (= |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|))
 (= |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|))
 (= |honda_main_#t~mem7| (+ |honda_main_#t~mem7| |ray_main_#t~mem7|))
 (= |honda_main_#t~mem8| (+ |honda_main_#t~mem8| |ray_main_#t~mem8|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~tmp~3.base (+ honda_main_~tmp~3.base ray_main_~tmp~3.base))
 (= |honda_(select old(#length) main_~id~2.base)|
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|))
 (= |honda_main_#t~nondet2|
 (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|))
 (= |honda_(select #length main_~id~2.base)|
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|))
 (= |honda_main_#t~mem11| (+ |honda_main_#t~mem11| |ray_main_#t~mem11|))
 (=
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|))
 (= |honda_(select #length main_~maxId~2.base)|
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|))
 (= honda_main_~maxId~2.offset
 (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|))
 (= |honda_main_#t~malloc10.base|
 (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|))
 (= |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~maxId~2.base)|
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|))
 (= |honda_main_#t~nondet4|
 (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|))
 (= honda_main_~maxId~2.base
 (+ honda_main_~maxId~2.base ray_main_~maxId~2.base))
 (= honda_main_~id~2.base (+ honda_main_~id~2.base ray_main_~id~2.base))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|))
 (= |honda_(select #length main_~tmp~3.base)|
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~tmp~3.offset
 (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset))
 (= |honda_(ite (select #valid main_~id~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 1)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) (- 1))
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) (- 1))
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 1)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 1)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| (- 1)) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 1)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc10.offset| (* |ray_main_#t~malloc10.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda))
 (= ray_main_~id~2.offset (* ray_main_~id~2.offset lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite main_#t~short9 1 0)| (* |ray_(ite main_#t~short9 1 0)| lambda))
 (= |ray_main_#t~mem6| (* |ray_main_#t~mem6| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select old(#length) main_~tmp~3.base)|
 (* |ray_(select old(#length) main_~tmp~3.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda))
 (= |ray_main_#t~mem7| (* |ray_main_#t~mem7| lambda))
 (= |ray_main_#t~mem8| (* |ray_main_#t~mem8| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~tmp~3.base (* ray_main_~tmp~3.base lambda))
 (= |ray_(select old(#length) main_~id~2.base)|
 (* |ray_(select old(#length) main_~id~2.base)| lambda))
 (= |ray_main_#t~nondet2| (* |ray_main_#t~nondet2| lambda))
 (= |ray_(select #length main_~id~2.base)|
 (* |ray_(select #length main_~id~2.base)| lambda))
 (= |ray_main_#t~mem11| (* |ray_main_#t~mem11| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda))
 (= |ray_(select #length main_~maxId~2.base)|
 (* |ray_(select #length main_~maxId~2.base)| lambda))
 (= ray_main_~maxId~2.offset (* ray_main_~maxId~2.offset lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda))
 (= |ray_main_#t~malloc10.base| (* |ray_main_#t~malloc10.base| lambda))
 (= |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~maxId~2.base)|
 (* |ray_(select old(#length) main_~maxId~2.base)| lambda))
 (= |ray_main_#t~nondet4| (* |ray_main_#t~nondet4| lambda))
 (= ray_main_~maxId~2.base (* ray_main_~maxId~2.base lambda))
 (= ray_main_~id~2.base (* ray_main_~id~2.base lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select #valid main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~tmp~3.base)|
 (* |ray_(select #length main_~tmp~3.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~tmp~3.offset (* ray_main_~tmp~3.offset lambda))
 (= |ray_(ite (select #valid main_~id~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 1)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* ray_main_~maxId~2.base lambda) (- 1))
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 1) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 1)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) (- 1))
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 1) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| (- 1)) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc10.offset|
 (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|))
 (= honda_main_~id~2.offset
 (+ honda_main_~id~2.offset ray_main_~id~2.offset))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite main_#t~short9 1 0)|
 (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|))
 (= |honda_main_#t~mem6| (+ |honda_main_#t~mem6| |ray_main_#t~mem6|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select old(#length) main_~tmp~3.base)|
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|))
 (= |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|))
 (= |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|))
 (= |honda_main_#t~mem7| (+ |honda_main_#t~mem7| |ray_main_#t~mem7|))
 (= |honda_main_#t~mem8| (+ |honda_main_#t~mem8| |ray_main_#t~mem8|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~tmp~3.base (+ honda_main_~tmp~3.base ray_main_~tmp~3.base))
 (= |honda_(select old(#length) main_~id~2.base)|
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|))
 (= |honda_main_#t~nondet2|
 (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|))
 (= |honda_(select #length main_~id~2.base)|
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|))
 (= |honda_main_#t~mem11| (+ |honda_main_#t~mem11| |ray_main_#t~mem11|))
 (=
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|))
 (= |honda_(select #length main_~maxId~2.base)|
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|))
 (= honda_main_~maxId~2.offset
 (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|))
 (= |honda_main_#t~malloc10.base|
 (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|))
 (= |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~maxId~2.base)|
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|))
 (= |honda_main_#t~nondet4|
 (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|))
 (= honda_main_~maxId~2.base
 (+ honda_main_~maxId~2.base ray_main_~maxId~2.base))
 (= honda_main_~id~2.base (+ honda_main_~id~2.base ray_main_~id~2.base))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|))
 (= |honda_(select #length main_~tmp~3.base)|
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~tmp~3.offset
 (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset))
 (= |honda_(ite (select #valid main_~id~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 1)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) (- 1))
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 1)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) (- 1))
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 1) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 1)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 1)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc10.offset| (* |ray_main_#t~malloc10.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda))
 (= ray_main_~id~2.offset (* ray_main_~id~2.offset lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite main_#t~short9 1 0)| (* |ray_(ite main_#t~short9 1 0)| lambda))
 (= |ray_main_#t~mem6| (* |ray_main_#t~mem6| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select old(#length) main_~tmp~3.base)|
 (* |ray_(select old(#length) main_~tmp~3.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda))
 (= |ray_main_#t~mem7| (* |ray_main_#t~mem7| lambda))
 (= |ray_main_#t~mem8| (* |ray_main_#t~mem8| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~tmp~3.base (* ray_main_~tmp~3.base lambda))
 (= |ray_(select old(#length) main_~id~2.base)|
 (* |ray_(select old(#length) main_~id~2.base)| lambda))
 (= |ray_main_#t~nondet2| (* |ray_main_#t~nondet2| lambda))
 (= |ray_(select #length main_~id~2.base)|
 (* |ray_(select #length main_~id~2.base)| lambda))
 (= |ray_main_#t~mem11| (* |ray_main_#t~mem11| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda))
 (= |ray_(select #length main_~maxId~2.base)|
 (* |ray_(select #length main_~maxId~2.base)| lambda))
 (= ray_main_~maxId~2.offset (* ray_main_~maxId~2.offset lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda))
 (= |ray_main_#t~malloc10.base| (* |ray_main_#t~malloc10.base| lambda))
 (= |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~maxId~2.base)|
 (* |ray_(select old(#length) main_~maxId~2.base)| lambda))
 (= |ray_main_#t~nondet4| (* |ray_main_#t~nondet4| lambda))
 (= ray_main_~maxId~2.base (* ray_main_~maxId~2.base lambda))
 (= ray_main_~id~2.base (* ray_main_~id~2.base lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select #valid main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~tmp~3.base)|
 (* |ray_(select #length main_~tmp~3.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~tmp~3.offset (* ray_main_~tmp~3.offset lambda))
 (= |ray_(ite (select #valid main_~id~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 1)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) (- 1))
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 1) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 1)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 1)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* ray_main_~maxId~2.base lambda) (- 1))
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 1) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc10.offset|
 (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|))
 (= honda_main_~id~2.offset
 (+ honda_main_~id~2.offset ray_main_~id~2.offset))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite main_#t~short9 1 0)|
 (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|))
 (= |honda_main_#t~mem6| (+ |honda_main_#t~mem6| |ray_main_#t~mem6|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select old(#length) main_~tmp~3.base)|
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|))
 (= |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|))
 (= |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|))
 (= |honda_main_#t~mem7| (+ |honda_main_#t~mem7| |ray_main_#t~mem7|))
 (= |honda_main_#t~mem8| (+ |honda_main_#t~mem8| |ray_main_#t~mem8|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~tmp~3.base (+ honda_main_~tmp~3.base ray_main_~tmp~3.base))
 (= |honda_(select old(#length) main_~id~2.base)|
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|))
 (= |honda_main_#t~nondet2|
 (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|))
 (= |honda_(select #length main_~id~2.base)|
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|))
 (= |honda_main_#t~mem11| (+ |honda_main_#t~mem11| |ray_main_#t~mem11|))
 (=
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|))
 (= |honda_(select #length main_~maxId~2.base)|
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|))
 (= honda_main_~maxId~2.offset
 (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|))
 (= |honda_main_#t~malloc10.base|
 (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|))
 (= |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~maxId~2.base)|
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|))
 (= |honda_main_#t~nondet4|
 (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|))
 (= honda_main_~maxId~2.base
 (+ honda_main_~maxId~2.base ray_main_~maxId~2.base))
 (= honda_main_~id~2.base (+ honda_main_~id~2.base ray_main_~id~2.base))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|))
 (= |honda_(select #length main_~tmp~3.base)|
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~tmp~3.offset
 (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset))
 (= |honda_(ite (select #valid main_~id~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 1)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) (- 1))
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 1)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 1)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| (- 1)) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 1)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc10.offset| (* |ray_main_#t~malloc10.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda))
 (= ray_main_~id~2.offset (* ray_main_~id~2.offset lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite main_#t~short9 1 0)| (* |ray_(ite main_#t~short9 1 0)| lambda))
 (= |ray_main_#t~mem6| (* |ray_main_#t~mem6| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select old(#length) main_~tmp~3.base)|
 (* |ray_(select old(#length) main_~tmp~3.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda))
 (= |ray_main_#t~mem7| (* |ray_main_#t~mem7| lambda))
 (= |ray_main_#t~mem8| (* |ray_main_#t~mem8| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~tmp~3.base (* ray_main_~tmp~3.base lambda))
 (= |ray_(select old(#length) main_~id~2.base)|
 (* |ray_(select old(#length) main_~id~2.base)| lambda))
 (= |ray_main_#t~nondet2| (* |ray_main_#t~nondet2| lambda))
 (= |ray_(select #length main_~id~2.base)|
 (* |ray_(select #length main_~id~2.base)| lambda))
 (= |ray_main_#t~mem11| (* |ray_main_#t~mem11| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda))
 (= |ray_(select #length main_~maxId~2.base)|
 (* |ray_(select #length main_~maxId~2.base)| lambda))
 (= ray_main_~maxId~2.offset (* ray_main_~maxId~2.offset lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda))
 (= |ray_main_#t~malloc10.base| (* |ray_main_#t~malloc10.base| lambda))
 (= |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~maxId~2.base)|
 (* |ray_(select old(#length) main_~maxId~2.base)| lambda))
 (= |ray_main_#t~nondet4| (* |ray_main_#t~nondet4| lambda))
 (= ray_main_~maxId~2.base (* ray_main_~maxId~2.base lambda))
 (= ray_main_~id~2.base (* ray_main_~id~2.base lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select #valid main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~tmp~3.base)|
 (* |ray_(select #length main_~tmp~3.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~tmp~3.offset (* ray_main_~tmp~3.offset lambda))
 (= |ray_(ite (select #valid main_~id~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 1)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) (- 1))
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 1) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 1)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 1) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* ray_main_~id~2.base lambda) (- 1)) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| (- 1)) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc10.offset|
 (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|))
 (= honda_main_~id~2.offset
 (+ honda_main_~id~2.offset ray_main_~id~2.offset))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite main_#t~short9 1 0)|
 (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|))
 (= |honda_main_#t~mem6| (+ |honda_main_#t~mem6| |ray_main_#t~mem6|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select old(#length) main_~tmp~3.base)|
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|))
 (= |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|))
 (= |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|))
 (= |honda_main_#t~mem7| (+ |honda_main_#t~mem7| |ray_main_#t~mem7|))
 (= |honda_main_#t~mem8| (+ |honda_main_#t~mem8| |ray_main_#t~mem8|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~tmp~3.base (+ honda_main_~tmp~3.base ray_main_~tmp~3.base))
 (= |honda_(select old(#length) main_~id~2.base)|
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|))
 (= |honda_main_#t~nondet2|
 (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|))
 (= |honda_(select #length main_~id~2.base)|
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|))
 (= |honda_main_#t~mem11| (+ |honda_main_#t~mem11| |ray_main_#t~mem11|))
 (=
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|))
 (= |honda_(select #length main_~maxId~2.base)|
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|))
 (= honda_main_~maxId~2.offset
 (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|))
 (= |honda_main_#t~malloc10.base|
 (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|))
 (= |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~maxId~2.base)|
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|))
 (= |honda_main_#t~nondet4|
 (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|))
 (= honda_main_~maxId~2.base
 (+ honda_main_~maxId~2.base ray_main_~maxId~2.base))
 (= honda_main_~id~2.base (+ honda_main_~id~2.base ray_main_~id~2.base))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|))
 (= |honda_(select #length main_~tmp~3.base)|
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~tmp~3.offset
 (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset))
 (= |honda_(ite (select #valid main_~id~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 1)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) (- 1))
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 1)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) (- 1))
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 1)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| (- 1)) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 1)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc10.offset| (* |ray_main_#t~malloc10.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda))
 (= ray_main_~id~2.offset (* ray_main_~id~2.offset lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite main_#t~short9 1 0)| (* |ray_(ite main_#t~short9 1 0)| lambda))
 (= |ray_main_#t~mem6| (* |ray_main_#t~mem6| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select old(#length) main_~tmp~3.base)|
 (* |ray_(select old(#length) main_~tmp~3.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda))
 (= |ray_main_#t~mem7| (* |ray_main_#t~mem7| lambda))
 (= |ray_main_#t~mem8| (* |ray_main_#t~mem8| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~tmp~3.base (* ray_main_~tmp~3.base lambda))
 (= |ray_(select old(#length) main_~id~2.base)|
 (* |ray_(select old(#length) main_~id~2.base)| lambda))
 (= |ray_main_#t~nondet2| (* |ray_main_#t~nondet2| lambda))
 (= |ray_(select #length main_~id~2.base)|
 (* |ray_(select #length main_~id~2.base)| lambda))
 (= |ray_main_#t~mem11| (* |ray_main_#t~mem11| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda))
 (= |ray_(select #length main_~maxId~2.base)|
 (* |ray_(select #length main_~maxId~2.base)| lambda))
 (= ray_main_~maxId~2.offset (* ray_main_~maxId~2.offset lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda))
 (= |ray_main_#t~malloc10.base| (* |ray_main_#t~malloc10.base| lambda))
 (= |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~maxId~2.base)|
 (* |ray_(select old(#length) main_~maxId~2.base)| lambda))
 (= |ray_main_#t~nondet4| (* |ray_main_#t~nondet4| lambda))
 (= ray_main_~maxId~2.base (* ray_main_~maxId~2.base lambda))
 (= ray_main_~id~2.base (* ray_main_~id~2.base lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select #valid main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~tmp~3.base)|
 (* |ray_(select #length main_~tmp~3.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~tmp~3.offset (* ray_main_~tmp~3.offset lambda))
 (= |ray_(ite (select #valid main_~id~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 1)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) (- 1))
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 1) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 1)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 1)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* ray_main_~maxId~2.base lambda) (- 1))
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| (- 1)) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc10.offset|
 (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|))
 (= honda_main_~id~2.offset
 (+ honda_main_~id~2.offset ray_main_~id~2.offset))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite main_#t~short9 1 0)|
 (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|))
 (= |honda_main_#t~mem6| (+ |honda_main_#t~mem6| |ray_main_#t~mem6|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select old(#length) main_~tmp~3.base)|
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|))
 (= |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|))
 (= |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|))
 (= |honda_main_#t~mem7| (+ |honda_main_#t~mem7| |ray_main_#t~mem7|))
 (= |honda_main_#t~mem8| (+ |honda_main_#t~mem8| |ray_main_#t~mem8|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~tmp~3.base (+ honda_main_~tmp~3.base ray_main_~tmp~3.base))
 (= |honda_(select old(#length) main_~id~2.base)|
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|))
 (= |honda_main_#t~nondet2|
 (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|))
 (= |honda_(select #length main_~id~2.base)|
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|))
 (= |honda_main_#t~mem11| (+ |honda_main_#t~mem11| |ray_main_#t~mem11|))
 (=
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|))
 (= |honda_(select #length main_~maxId~2.base)|
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|))
 (= honda_main_~maxId~2.offset
 (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|))
 (= |honda_main_#t~malloc10.base|
 (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|))
 (= |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~maxId~2.base)|
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|))
 (= |honda_main_#t~nondet4|
 (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|))
 (= honda_main_~maxId~2.base
 (+ honda_main_~maxId~2.base ray_main_~maxId~2.base))
 (= honda_main_~id~2.base (+ honda_main_~id~2.base ray_main_~id~2.base))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|))
 (= |honda_(select #length main_~tmp~3.base)|
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~tmp~3.offset
 (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset))
 (= |honda_(ite (select #valid main_~id~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 1)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) (- 1))
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) (- 1))
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 1)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 1)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| (- 1)) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 1)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc10.offset| (* |ray_main_#t~malloc10.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda))
 (= ray_main_~id~2.offset (* ray_main_~id~2.offset lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite main_#t~short9 1 0)| (* |ray_(ite main_#t~short9 1 0)| lambda))
 (= |ray_main_#t~mem6| (* |ray_main_#t~mem6| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select old(#length) main_~tmp~3.base)|
 (* |ray_(select old(#length) main_~tmp~3.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda))
 (= |ray_main_#t~mem7| (* |ray_main_#t~mem7| lambda))
 (= |ray_main_#t~mem8| (* |ray_main_#t~mem8| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~tmp~3.base (* ray_main_~tmp~3.base lambda))
 (= |ray_(select old(#length) main_~id~2.base)|
 (* |ray_(select old(#length) main_~id~2.base)| lambda))
 (= |ray_main_#t~nondet2| (* |ray_main_#t~nondet2| lambda))
 (= |ray_(select #length main_~id~2.base)|
 (* |ray_(select #length main_~id~2.base)| lambda))
 (= |ray_main_#t~mem11| (* |ray_main_#t~mem11| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda))
 (= |ray_(select #length main_~maxId~2.base)|
 (* |ray_(select #length main_~maxId~2.base)| lambda))
 (= ray_main_~maxId~2.offset (* ray_main_~maxId~2.offset lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda))
 (= |ray_main_#t~malloc10.base| (* |ray_main_#t~malloc10.base| lambda))
 (= |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~maxId~2.base)|
 (* |ray_(select old(#length) main_~maxId~2.base)| lambda))
 (= |ray_main_#t~nondet4| (* |ray_main_#t~nondet4| lambda))
 (= ray_main_~maxId~2.base (* ray_main_~maxId~2.base lambda))
 (= ray_main_~id~2.base (* ray_main_~id~2.base lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select #valid main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~tmp~3.base)|
 (* |ray_(select #length main_~tmp~3.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~tmp~3.offset (* ray_main_~tmp~3.offset lambda))
 (= |ray_(ite (select #valid main_~id~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 1)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* ray_main_~maxId~2.base lambda) (- 1))
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 1) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 1)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) (- 1))
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 1) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| (- 1)) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc10.offset|
 (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|))
 (= honda_main_~id~2.offset
 (+ honda_main_~id~2.offset ray_main_~id~2.offset))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite main_#t~short9 1 0)|
 (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|))
 (= |honda_main_#t~mem6| (+ |honda_main_#t~mem6| |ray_main_#t~mem6|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select old(#length) main_~tmp~3.base)|
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|))
 (= |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|))
 (= |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|))
 (= |honda_main_#t~mem7| (+ |honda_main_#t~mem7| |ray_main_#t~mem7|))
 (= |honda_main_#t~mem8| (+ |honda_main_#t~mem8| |ray_main_#t~mem8|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~tmp~3.base (+ honda_main_~tmp~3.base ray_main_~tmp~3.base))
 (= |honda_(select old(#length) main_~id~2.base)|
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|))
 (= |honda_main_#t~nondet2|
 (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|))
 (= |honda_(select #length main_~id~2.base)|
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|))
 (= |honda_main_#t~mem11| (+ |honda_main_#t~mem11| |ray_main_#t~mem11|))
 (=
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|))
 (= |honda_(select #length main_~maxId~2.base)|
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|))
 (= honda_main_~maxId~2.offset
 (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|))
 (= |honda_main_#t~malloc10.base|
 (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|))
 (= |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~maxId~2.base)|
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|))
 (= |honda_main_#t~nondet4|
 (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|))
 (= honda_main_~maxId~2.base
 (+ honda_main_~maxId~2.base ray_main_~maxId~2.base))
 (= honda_main_~id~2.base (+ honda_main_~id~2.base ray_main_~id~2.base))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|))
 (= |honda_(select #length main_~tmp~3.base)|
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~tmp~3.offset
 (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset))
 (= |honda_(ite (select #valid main_~id~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 1)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) (- 1))
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 1)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) (- 1))
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 1)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| (- 1)) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 1)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc10.offset| (* |ray_main_#t~malloc10.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda))
 (= ray_main_~id~2.offset (* ray_main_~id~2.offset lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite main_#t~short9 1 0)| (* |ray_(ite main_#t~short9 1 0)| lambda))
 (= |ray_main_#t~mem6| (* |ray_main_#t~mem6| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select old(#length) main_~tmp~3.base)|
 (* |ray_(select old(#length) main_~tmp~3.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda))
 (= |ray_main_#t~mem7| (* |ray_main_#t~mem7| lambda))
 (= |ray_main_#t~mem8| (* |ray_main_#t~mem8| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~tmp~3.base (* ray_main_~tmp~3.base lambda))
 (= |ray_(select old(#length) main_~id~2.base)|
 (* |ray_(select old(#length) main_~id~2.base)| lambda))
 (= |ray_main_#t~nondet2| (* |ray_main_#t~nondet2| lambda))
 (= |ray_(select #length main_~id~2.base)|
 (* |ray_(select #length main_~id~2.base)| lambda))
 (= |ray_main_#t~mem11| (* |ray_main_#t~mem11| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda))
 (= |ray_(select #length main_~maxId~2.base)|
 (* |ray_(select #length main_~maxId~2.base)| lambda))
 (= ray_main_~maxId~2.offset (* ray_main_~maxId~2.offset lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda))
 (= |ray_main_#t~malloc10.base| (* |ray_main_#t~malloc10.base| lambda))
 (= |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~maxId~2.base)|
 (* |ray_(select old(#length) main_~maxId~2.base)| lambda))
 (= |ray_main_#t~nondet4| (* |ray_main_#t~nondet4| lambda))
 (= ray_main_~maxId~2.base (* ray_main_~maxId~2.base lambda))
 (= ray_main_~id~2.base (* ray_main_~id~2.base lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select #valid main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~tmp~3.base)|
 (* |ray_(select #length main_~tmp~3.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~tmp~3.offset (* ray_main_~tmp~3.offset lambda))
 (= |ray_(ite (select #valid main_~id~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 1)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) (- 1))
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 1) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 1)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 1)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* ray_main_~maxId~2.base lambda) (- 1))
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| (- 1)) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc10.offset|
 (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|))
 (= honda_main_~id~2.offset
 (+ honda_main_~id~2.offset ray_main_~id~2.offset))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite main_#t~short9 1 0)|
 (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|))
 (= |honda_main_#t~mem6| (+ |honda_main_#t~mem6| |ray_main_#t~mem6|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select old(#length) main_~tmp~3.base)|
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|))
 (= |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|))
 (= |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|))
 (= |honda_main_#t~mem7| (+ |honda_main_#t~mem7| |ray_main_#t~mem7|))
 (= |honda_main_#t~mem8| (+ |honda_main_#t~mem8| |ray_main_#t~mem8|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~tmp~3.base (+ honda_main_~tmp~3.base ray_main_~tmp~3.base))
 (= |honda_(select old(#length) main_~id~2.base)|
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|))
 (= |honda_main_#t~nondet2|
 (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|))
 (= |honda_(select #length main_~id~2.base)|
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|))
 (= |honda_main_#t~mem11| (+ |honda_main_#t~mem11| |ray_main_#t~mem11|))
 (=
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|))
 (= |honda_(select #length main_~maxId~2.base)|
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|))
 (= honda_main_~maxId~2.offset
 (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|))
 (= |honda_main_#t~malloc10.base|
 (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|))
 (= |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~maxId~2.base)|
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|))
 (= |honda_main_#t~nondet4|
 (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|))
 (= honda_main_~maxId~2.base
 (+ honda_main_~maxId~2.base ray_main_~maxId~2.base))
 (= honda_main_~id~2.base (+ honda_main_~id~2.base ray_main_~id~2.base))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|))
 (= |honda_(select #length main_~tmp~3.base)|
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~tmp~3.offset
 (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset))
 (= |honda_(ite (select #valid main_~id~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 1)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) (- 1))
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 1)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 1) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 1)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 1)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 1)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc10.offset| (* |ray_main_#t~malloc10.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda))
 (= ray_main_~id~2.offset (* ray_main_~id~2.offset lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite main_#t~short9 1 0)| (* |ray_(ite main_#t~short9 1 0)| lambda))
 (= |ray_main_#t~mem6| (* |ray_main_#t~mem6| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select old(#length) main_~tmp~3.base)|
 (* |ray_(select old(#length) main_~tmp~3.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda))
 (= |ray_main_#t~mem7| (* |ray_main_#t~mem7| lambda))
 (= |ray_main_#t~mem8| (* |ray_main_#t~mem8| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~tmp~3.base (* ray_main_~tmp~3.base lambda))
 (= |ray_(select old(#length) main_~id~2.base)|
 (* |ray_(select old(#length) main_~id~2.base)| lambda))
 (= |ray_main_#t~nondet2| (* |ray_main_#t~nondet2| lambda))
 (= |ray_(select #length main_~id~2.base)|
 (* |ray_(select #length main_~id~2.base)| lambda))
 (= |ray_main_#t~mem11| (* |ray_main_#t~mem11| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda))
 (= |ray_(select #length main_~maxId~2.base)|
 (* |ray_(select #length main_~maxId~2.base)| lambda))
 (= ray_main_~maxId~2.offset (* ray_main_~maxId~2.offset lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda))
 (= |ray_main_#t~malloc10.base| (* |ray_main_#t~malloc10.base| lambda))
 (= |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~maxId~2.base)|
 (* |ray_(select old(#length) main_~maxId~2.base)| lambda))
 (= |ray_main_#t~nondet4| (* |ray_main_#t~nondet4| lambda))
 (= ray_main_~maxId~2.base (* ray_main_~maxId~2.base lambda))
 (= ray_main_~id~2.base (* ray_main_~id~2.base lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select #valid main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~tmp~3.base)|
 (* |ray_(select #length main_~tmp~3.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~tmp~3.offset (* ray_main_~tmp~3.offset lambda))
 (= |ray_(ite (select #valid main_~id~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 1)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 1)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) (- 1))
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 1) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 1) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 1)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* ray_main_~id~2.base lambda) (- 1)) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc10.offset|
 (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|))
 (= honda_main_~id~2.offset
 (+ honda_main_~id~2.offset ray_main_~id~2.offset))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite main_#t~short9 1 0)|
 (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|))
 (= |honda_main_#t~mem6| (+ |honda_main_#t~mem6| |ray_main_#t~mem6|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select old(#length) main_~tmp~3.base)|
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|))
 (= |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|))
 (= |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|))
 (= |honda_main_#t~mem7| (+ |honda_main_#t~mem7| |ray_main_#t~mem7|))
 (= |honda_main_#t~mem8| (+ |honda_main_#t~mem8| |ray_main_#t~mem8|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~tmp~3.base (+ honda_main_~tmp~3.base ray_main_~tmp~3.base))
 (= |honda_(select old(#length) main_~id~2.base)|
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|))
 (= |honda_main_#t~nondet2|
 (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|))
 (= |honda_(select #length main_~id~2.base)|
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|))
 (= |honda_main_#t~mem11| (+ |honda_main_#t~mem11| |ray_main_#t~mem11|))
 (=
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|))
 (= |honda_(select #length main_~maxId~2.base)|
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|))
 (= honda_main_~maxId~2.offset
 (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|))
 (= |honda_main_#t~malloc10.base|
 (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|))
 (= |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~maxId~2.base)|
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|))
 (= |honda_main_#t~nondet4|
 (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|))
 (= honda_main_~maxId~2.base
 (+ honda_main_~maxId~2.base ray_main_~maxId~2.base))
 (= honda_main_~id~2.base (+ honda_main_~id~2.base ray_main_~id~2.base))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|))
 (= |honda_(select #length main_~tmp~3.base)|
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~tmp~3.offset
 (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset))
 (= |honda_(ite (select #valid main_~id~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 1)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) (- 1))
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 1)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 1)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| (- 1)) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 1)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc10.offset| (* |ray_main_#t~malloc10.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda))
 (= ray_main_~id~2.offset (* ray_main_~id~2.offset lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite main_#t~short9 1 0)| (* |ray_(ite main_#t~short9 1 0)| lambda))
 (= |ray_main_#t~mem6| (* |ray_main_#t~mem6| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select old(#length) main_~tmp~3.base)|
 (* |ray_(select old(#length) main_~tmp~3.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda))
 (= |ray_main_#t~mem7| (* |ray_main_#t~mem7| lambda))
 (= |ray_main_#t~mem8| (* |ray_main_#t~mem8| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~tmp~3.base (* ray_main_~tmp~3.base lambda))
 (= |ray_(select old(#length) main_~id~2.base)|
 (* |ray_(select old(#length) main_~id~2.base)| lambda))
 (= |ray_main_#t~nondet2| (* |ray_main_#t~nondet2| lambda))
 (= |ray_(select #length main_~id~2.base)|
 (* |ray_(select #length main_~id~2.base)| lambda))
 (= |ray_main_#t~mem11| (* |ray_main_#t~mem11| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda))
 (= |ray_(select #length main_~maxId~2.base)|
 (* |ray_(select #length main_~maxId~2.base)| lambda))
 (= ray_main_~maxId~2.offset (* ray_main_~maxId~2.offset lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda))
 (= |ray_main_#t~malloc10.base| (* |ray_main_#t~malloc10.base| lambda))
 (= |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~maxId~2.base)|
 (* |ray_(select old(#length) main_~maxId~2.base)| lambda))
 (= |ray_main_#t~nondet4| (* |ray_main_#t~nondet4| lambda))
 (= ray_main_~maxId~2.base (* ray_main_~maxId~2.base lambda))
 (= ray_main_~id~2.base (* ray_main_~id~2.base lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select #valid main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~tmp~3.base)|
 (* |ray_(select #length main_~tmp~3.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~tmp~3.offset (* ray_main_~tmp~3.offset lambda))
 (= |ray_(ite (select #valid main_~id~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 1)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* ray_main_~maxId~2.base lambda) (- 1))
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 1) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 1)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 1)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* ray_main_~id~2.base lambda) (- 1)) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| (- 1)) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc10.offset|
 (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|))
 (= honda_main_~id~2.offset
 (+ honda_main_~id~2.offset ray_main_~id~2.offset))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite main_#t~short9 1 0)|
 (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|))
 (= |honda_main_#t~mem6| (+ |honda_main_#t~mem6| |ray_main_#t~mem6|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select old(#length) main_~tmp~3.base)|
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|))
 (= |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|))
 (= |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|))
 (= |honda_main_#t~mem7| (+ |honda_main_#t~mem7| |ray_main_#t~mem7|))
 (= |honda_main_#t~mem8| (+ |honda_main_#t~mem8| |ray_main_#t~mem8|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~tmp~3.base (+ honda_main_~tmp~3.base ray_main_~tmp~3.base))
 (= |honda_(select old(#length) main_~id~2.base)|
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|))
 (= |honda_main_#t~nondet2|
 (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|))
 (= |honda_(select #length main_~id~2.base)|
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|))
 (= |honda_main_#t~mem11| (+ |honda_main_#t~mem11| |ray_main_#t~mem11|))
 (=
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|))
 (= |honda_(select #length main_~maxId~2.base)|
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|))
 (= honda_main_~maxId~2.offset
 (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|))
 (= |honda_main_#t~malloc10.base|
 (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|))
 (= |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~maxId~2.base)|
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|))
 (= |honda_main_#t~nondet4|
 (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|))
 (= honda_main_~maxId~2.base
 (+ honda_main_~maxId~2.base ray_main_~maxId~2.base))
 (= honda_main_~id~2.base (+ honda_main_~id~2.base ray_main_~id~2.base))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|))
 (= |honda_(select #length main_~tmp~3.base)|
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~tmp~3.offset
 (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset))
 (= |honda_(ite (select #valid main_~id~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 1)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) (- 1))
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 1)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 1)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 1)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| (- 1)) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 1)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc10.offset| (* |ray_main_#t~malloc10.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda))
 (= ray_main_~id~2.offset (* ray_main_~id~2.offset lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite main_#t~short9 1 0)| (* |ray_(ite main_#t~short9 1 0)| lambda))
 (= |ray_main_#t~mem6| (* |ray_main_#t~mem6| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select old(#length) main_~tmp~3.base)|
 (* |ray_(select old(#length) main_~tmp~3.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda))
 (= |ray_main_#t~mem7| (* |ray_main_#t~mem7| lambda))
 (= |ray_main_#t~mem8| (* |ray_main_#t~mem8| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~tmp~3.base (* ray_main_~tmp~3.base lambda))
 (= |ray_(select old(#length) main_~id~2.base)|
 (* |ray_(select old(#length) main_~id~2.base)| lambda))
 (= |ray_main_#t~nondet2| (* |ray_main_#t~nondet2| lambda))
 (= |ray_(select #length main_~id~2.base)|
 (* |ray_(select #length main_~id~2.base)| lambda))
 (= |ray_main_#t~mem11| (* |ray_main_#t~mem11| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda))
 (= |ray_(select #length main_~maxId~2.base)|
 (* |ray_(select #length main_~maxId~2.base)| lambda))
 (= ray_main_~maxId~2.offset (* ray_main_~maxId~2.offset lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda))
 (= |ray_main_#t~malloc10.base| (* |ray_main_#t~malloc10.base| lambda))
 (= |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~maxId~2.base)|
 (* |ray_(select old(#length) main_~maxId~2.base)| lambda))
 (= |ray_main_#t~nondet4| (* |ray_main_#t~nondet4| lambda))
 (= ray_main_~maxId~2.base (* ray_main_~maxId~2.base lambda))
 (= ray_main_~id~2.base (* ray_main_~id~2.base lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select #valid main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~tmp~3.base)|
 (* |ray_(select #length main_~tmp~3.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~tmp~3.offset (* ray_main_~tmp~3.offset lambda))
 (= |ray_(ite (select #valid main_~id~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 1)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 1)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) (- 1))
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 1) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 1)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* ray_main_~id~2.base lambda) (- 1)) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| (- 1)) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc10.offset|
 (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|))
 (= honda_main_~id~2.offset
 (+ honda_main_~id~2.offset ray_main_~id~2.offset))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite main_#t~short9 1 0)|
 (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|))
 (= |honda_main_#t~mem6| (+ |honda_main_#t~mem6| |ray_main_#t~mem6|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select old(#length) main_~tmp~3.base)|
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|))
 (= |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|))
 (= |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|))
 (= |honda_main_#t~mem7| (+ |honda_main_#t~mem7| |ray_main_#t~mem7|))
 (= |honda_main_#t~mem8| (+ |honda_main_#t~mem8| |ray_main_#t~mem8|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~tmp~3.base (+ honda_main_~tmp~3.base ray_main_~tmp~3.base))
 (= |honda_(select old(#length) main_~id~2.base)|
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|))
 (= |honda_main_#t~nondet2|
 (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|))
 (= |honda_(select #length main_~id~2.base)|
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|))
 (= |honda_main_#t~mem11| (+ |honda_main_#t~mem11| |ray_main_#t~mem11|))
 (=
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|))
 (= |honda_(select #length main_~maxId~2.base)|
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|))
 (= honda_main_~maxId~2.offset
 (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|))
 (= |honda_main_#t~malloc10.base|
 (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|))
 (= |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~maxId~2.base)|
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|))
 (= |honda_main_#t~nondet4|
 (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|))
 (= honda_main_~maxId~2.base
 (+ honda_main_~maxId~2.base ray_main_~maxId~2.base))
 (= honda_main_~id~2.base (+ honda_main_~id~2.base ray_main_~id~2.base))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|))
 (= |honda_(select #length main_~tmp~3.base)|
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~tmp~3.offset
 (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset))
 (= |honda_(ite (select #valid main_~id~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 1)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) (- 1))
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 1)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) (- 1))
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 1) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 1)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 1)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc10.offset| (* |ray_main_#t~malloc10.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda))
 (= ray_main_~id~2.offset (* ray_main_~id~2.offset lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite main_#t~short9 1 0)| (* |ray_(ite main_#t~short9 1 0)| lambda))
 (= |ray_main_#t~mem6| (* |ray_main_#t~mem6| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select old(#length) main_~tmp~3.base)|
 (* |ray_(select old(#length) main_~tmp~3.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda))
 (= |ray_main_#t~mem7| (* |ray_main_#t~mem7| lambda))
 (= |ray_main_#t~mem8| (* |ray_main_#t~mem8| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~tmp~3.base (* ray_main_~tmp~3.base lambda))
 (= |ray_(select old(#length) main_~id~2.base)|
 (* |ray_(select old(#length) main_~id~2.base)| lambda))
 (= |ray_main_#t~nondet2| (* |ray_main_#t~nondet2| lambda))
 (= |ray_(select #length main_~id~2.base)|
 (* |ray_(select #length main_~id~2.base)| lambda))
 (= |ray_main_#t~mem11| (* |ray_main_#t~mem11| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda))
 (= |ray_(select #length main_~maxId~2.base)|
 (* |ray_(select #length main_~maxId~2.base)| lambda))
 (= ray_main_~maxId~2.offset (* ray_main_~maxId~2.offset lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda))
 (= |ray_main_#t~malloc10.base| (* |ray_main_#t~malloc10.base| lambda))
 (= |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~maxId~2.base)|
 (* |ray_(select old(#length) main_~maxId~2.base)| lambda))
 (= |ray_main_#t~nondet4| (* |ray_main_#t~nondet4| lambda))
 (= ray_main_~maxId~2.base (* ray_main_~maxId~2.base lambda))
 (= ray_main_~id~2.base (* ray_main_~id~2.base lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select #valid main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~tmp~3.base)|
 (* |ray_(select #length main_~tmp~3.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~tmp~3.offset (* ray_main_~tmp~3.offset lambda))
 (= |ray_(ite (select #valid main_~id~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 1)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) (- 1))
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 1) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 1)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 1)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* ray_main_~maxId~2.base lambda) (- 1))
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 1) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc10.offset|
 (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|))
 (= honda_main_~id~2.offset
 (+ honda_main_~id~2.offset ray_main_~id~2.offset))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite main_#t~short9 1 0)|
 (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|))
 (= |honda_main_#t~mem6| (+ |honda_main_#t~mem6| |ray_main_#t~mem6|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select old(#length) main_~tmp~3.base)|
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|))
 (= |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|))
 (= |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|))
 (= |honda_main_#t~mem7| (+ |honda_main_#t~mem7| |ray_main_#t~mem7|))
 (= |honda_main_#t~mem8| (+ |honda_main_#t~mem8| |ray_main_#t~mem8|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~tmp~3.base (+ honda_main_~tmp~3.base ray_main_~tmp~3.base))
 (= |honda_(select old(#length) main_~id~2.base)|
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|))
 (= |honda_main_#t~nondet2|
 (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|))
 (= |honda_(select #length main_~id~2.base)|
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|))
 (= |honda_main_#t~mem11| (+ |honda_main_#t~mem11| |ray_main_#t~mem11|))
 (=
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|))
 (= |honda_(select #length main_~maxId~2.base)|
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|))
 (= honda_main_~maxId~2.offset
 (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|))
 (= |honda_main_#t~malloc10.base|
 (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|))
 (= |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~maxId~2.base)|
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|))
 (= |honda_main_#t~nondet4|
 (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|))
 (= honda_main_~maxId~2.base
 (+ honda_main_~maxId~2.base ray_main_~maxId~2.base))
 (= honda_main_~id~2.base (+ honda_main_~id~2.base ray_main_~id~2.base))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|))
 (= |honda_(select #length main_~tmp~3.base)|
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~tmp~3.offset
 (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset))
 (= |honda_(ite (select #valid main_~id~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 1)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) (- 1))
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 1) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 1)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 1)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 1)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc10.offset| (* |ray_main_#t~malloc10.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda))
 (= ray_main_~id~2.offset (* ray_main_~id~2.offset lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite main_#t~short9 1 0)| (* |ray_(ite main_#t~short9 1 0)| lambda))
 (= |ray_main_#t~mem6| (* |ray_main_#t~mem6| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select old(#length) main_~tmp~3.base)|
 (* |ray_(select old(#length) main_~tmp~3.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda))
 (= |ray_main_#t~mem7| (* |ray_main_#t~mem7| lambda))
 (= |ray_main_#t~mem8| (* |ray_main_#t~mem8| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~tmp~3.base (* ray_main_~tmp~3.base lambda))
 (= |ray_(select old(#length) main_~id~2.base)|
 (* |ray_(select old(#length) main_~id~2.base)| lambda))
 (= |ray_main_#t~nondet2| (* |ray_main_#t~nondet2| lambda))
 (= |ray_(select #length main_~id~2.base)|
 (* |ray_(select #length main_~id~2.base)| lambda))
 (= |ray_main_#t~mem11| (* |ray_main_#t~mem11| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda))
 (= |ray_(select #length main_~maxId~2.base)|
 (* |ray_(select #length main_~maxId~2.base)| lambda))
 (= ray_main_~maxId~2.offset (* ray_main_~maxId~2.offset lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda))
 (= |ray_main_#t~malloc10.base| (* |ray_main_#t~malloc10.base| lambda))
 (= |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~maxId~2.base)|
 (* |ray_(select old(#length) main_~maxId~2.base)| lambda))
 (= |ray_main_#t~nondet4| (* |ray_main_#t~nondet4| lambda))
 (= ray_main_~maxId~2.base (* ray_main_~maxId~2.base lambda))
 (= ray_main_~id~2.base (* ray_main_~id~2.base lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select #valid main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~tmp~3.base)|
 (* |ray_(select #length main_~tmp~3.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~tmp~3.offset (* ray_main_~tmp~3.offset lambda))
 (= |ray_(ite (select #valid main_~id~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 1)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* ray_main_~maxId~2.base lambda) (- 1))
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 1) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 1)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 1) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 1)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* ray_main_~id~2.base lambda) (- 1)) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc10.offset|
 (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|))
 (= honda_main_~id~2.offset
 (+ honda_main_~id~2.offset ray_main_~id~2.offset))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite main_#t~short9 1 0)|
 (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|))
 (= |honda_main_#t~mem6| (+ |honda_main_#t~mem6| |ray_main_#t~mem6|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_(select old(#length) main_~tmp~3.base)|
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|))
 (= |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|))
 (= |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|))
 (= |honda_main_#t~mem7| (+ |honda_main_#t~mem7| |ray_main_#t~mem7|))
 (= |honda_main_#t~mem8| (+ |honda_main_#t~mem8| |ray_main_#t~mem8|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~tmp~3.base (+ honda_main_~tmp~3.base ray_main_~tmp~3.base))
 (= |honda_(select old(#length) main_~id~2.base)|
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|))
 (= |honda_main_#t~nondet2|
 (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|))
 (= |honda_(select #length main_~id~2.base)|
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|))
 (= |honda_main_#t~mem11| (+ |honda_main_#t~mem11| |ray_main_#t~mem11|))
 (=
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|))
 (= |honda_(select #length main_~maxId~2.base)|
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|))
 (= honda_main_~maxId~2.offset
 (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|))
 (= |honda_main_#t~malloc10.base|
 (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|))
 (= |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~maxId~2.base)|
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|))
 (= |honda_main_#t~nondet4|
 (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|))
 (= honda_main_~maxId~2.base
 (+ honda_main_~maxId~2.base ray_main_~maxId~2.base))
 (= honda_main_~id~2.base (+ honda_main_~id~2.base ray_main_~id~2.base))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|))
 (= |honda_(select #length main_~tmp~3.base)|
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~tmp~3.offset
 (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset))
 (= |honda_(ite (select #valid main_~id~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 1)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 1)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 1)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 1) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) (- 1))
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|)
 (- 1)) (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 1) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|)
 (- 1)) (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 1)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 1)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) (- 1))
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 1)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 1)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| (- 1)) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) (- 1))
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 1)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc10.offset| |ray_main_#t~malloc10.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|) 0)
 (* (+ honda_main_~id~2.offset ray_main_~id~2.offset) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short9 1 0)| |ray_(ite main_#t~short9 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (*
 (+ |honda_(select old(#length) main_~tmp~3.base)|
 |ray_(select old(#length) main_~tmp~3.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|)
 0)
 (*
 (+ |honda_(ite (select #valid main_~tmp~3.base) 1 0)|
 |ray_(ite (select #valid main_~tmp~3.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem7| |ray_main_#t~mem7|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|) 0)
 (* (+ |honda_main_#t~mem8| |ray_main_#t~mem8|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~tmp~3.base ray_main_~tmp~3.base) 0)
 (*
 (+ |honda_(select old(#length) main_~id~2.base)|
 |ray_(select old(#length) main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~nondet2| |ray_main_#t~nondet2|) 0)
 (*
 (+ |honda_(select #length main_~id~2.base)|
 |ray_(select #length main_~id~2.base)|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (* (+ |honda_main_#t~mem16| |ray_main_#t~mem16|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|)
 0) (* (+ |honda_main_#t~mem13| |ray_main_#t~mem13|) 0)
 (*
 (+ |honda_(select #length main_~maxId~2.base)|
 |ray_(select #length main_~maxId~2.base)|) 0)
 (* (+ |honda_main_#t~mem18| |ray_main_#t~mem18|) 0)
 (* (+ honda_main_~maxId~2.offset ray_main_~maxId~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|)
 0) (* (+ |honda_main_#t~malloc10.base| |ray_main_#t~malloc10.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~id~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~maxId~2.base)|
 |ray_(select old(#length) main_~maxId~2.base)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|) 0)
 (* (+ |honda_main_#t~nondet4| |ray_main_#t~nondet4|) 0)
 (* (+ |honda_main_#t~nondet15| |ray_main_#t~nondet15|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (* (+ honda_main_~maxId~2.base ray_main_~maxId~2.base) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ honda_main_~id~2.base ray_main_~id~2.base) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid main_~maxId~2.base) 1 0)|
 |ray_(ite (select #valid main_~maxId~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~tmp~3.base)|
 |ray_(select #length main_~tmp~3.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~tmp~3.offset ray_main_~tmp~3.offset) 0)
 (*
 (+ |honda_(ite (select #valid main_~id~2.base) 1 0)|
 |ray_(ite (select #valid main_~id~2.base) 1 0)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (*
 |honda_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 0) (* |honda_main_#t~mem16| 0) 
 (* |honda_main_#t~mem13| 0) 
 (* |honda_main_#t~mem18| 0)
 (* |honda_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |honda_main_#t~nondet15| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc10.offset| (* |ray_main_#t~malloc10.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda))
 (= ray_main_~id~2.offset (* ray_main_~id~2.offset lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite main_#t~short9 1 0)| (* |ray_(ite main_#t~short9 1 0)| lambda))
 (= |ray_main_#t~mem6| (* |ray_main_#t~mem6| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_(select old(#length) main_~tmp~3.base)|
 (* |ray_(select old(#length) main_~tmp~3.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda))
 (= |ray_(ite (select #valid main_~tmp~3.base) 1 0)|
 (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda))
 (= |ray_main_#t~mem7| (* |ray_main_#t~mem7| lambda))
 (= |ray_main_#t~mem8| (* |ray_main_#t~mem8| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~tmp~3.base (* ray_main_~tmp~3.base lambda))
 (= |ray_(select old(#length) main_~id~2.base)|
 (* |ray_(select old(#length) main_~id~2.base)| lambda))
 (= |ray_main_#t~nondet2| (* |ray_main_#t~nondet2| lambda))
 (= |ray_(select #length main_~id~2.base)|
 (* |ray_(select #length main_~id~2.base)| lambda))
 (= |ray_main_#t~mem11| (* |ray_main_#t~mem11| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda))
 (= |ray_(select #length main_~maxId~2.base)|
 (* |ray_(select #length main_~maxId~2.base)| lambda))
 (= ray_main_~maxId~2.offset (* ray_main_~maxId~2.offset lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda))
 (= |ray_main_#t~malloc10.base| (* |ray_main_#t~malloc10.base| lambda))
 (= |ray_(ite (select old(#valid) main_~id~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~maxId~2.base)|
 (* |ray_(select old(#length) main_~maxId~2.base)| lambda))
 (= |ray_main_#t~nondet4| (* |ray_main_#t~nondet4| lambda))
 (= ray_main_~maxId~2.base (* ray_main_~maxId~2.base lambda))
 (= ray_main_~id~2.base (* ray_main_~id~2.base lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(ite (select #valid main_~maxId~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~tmp~3.base)|
 (* |ray_(select #length main_~tmp~3.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~tmp~3.offset (* ray_main_~tmp~3.offset lambda))
 (= |ray_(ite (select #valid main_~id~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 1)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 1) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 (- 1)) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 1)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 1)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 1)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 1)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 1) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 1) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* ray_main_~id~2.base lambda) (- 1)) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 1)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* ray_main_~maxId~2.base lambda) (- 1))
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 1) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 (- 1)) (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| (- 1)) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) (- 1))
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc10.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~id~2.offset lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short9 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem6| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_(select old(#length) main_~tmp~3.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~tmp~3.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~tmp~3.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem7| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem8| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~tmp~3.base lambda) 0)
 (* (* |ray_(select old(#length) main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet2| lambda) 0)
 (* (* |ray_(select #length main_~id~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem11| lambda) 0) 
 (* (* |ray_main_#t~mem16| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~mem13| lambda) 0)
 (* (* |ray_(select #length main_~maxId~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem18| lambda) 0)
 (* (* ray_main_~maxId~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) main_~maxId~2.base) main_~maxId~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc10.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~maxId~2.base)| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 lambda) 0) (* (* |ray_main_#t~nondet4| lambda) 0)
 (* (* |ray_main_#t~nondet15| lambda) 0) 
 (* (* |ray_main_#t~mem17| lambda) 0) 
 (* (* ray_main_~maxId~2.base lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0) 
 (* (* ray_main_~id~2.base lambda) 0) 
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid main_~maxId~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~tmp~3.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~tmp~3.offset lambda) 0)
 (* (* |ray_(ite (select #valid main_~id~2.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0)
 (*
 |ray_(select (select #memory_int main_~maxId~2.base) main_~maxId~2.offset)|
 0)
 (* |ray_(select (select #memory_int main_~id~2.base) main_~id~2.offset)| 0)
 (* |ray_main_#t~mem16| 0) 
 (* |ray_main_#t~mem13| 0) 
 (* |ray_main_#t~mem18| 0)
 (* |ray_(select (select #memory_int main_~tmp~3.base) main_~tmp~3.offset)|
 0) (* |ray_main_#t~nondet15| 0) 
 (* |ray_main_#t~mem17| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))) (>= lambda 0)))
(check-sat)
(exit)

